var jszip = require('jszip');

class HttpCli {
    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    // start () {},

    // update (dt) {},

    constructor(){
        this.cachemsg = [];
        this._needretry = false;
        this._retrycount = 3;
        this._retryms = 3000;
        this._runningcount = 0;
        this._maxrunning = 10;
        // this._retry_tid = setInterval(this._retry.bind(this), this._retryms);
    }

    httpGet(url, cbRes, cbErr, retrycount){
        // var realurl = url;
        // if(urldata){
        //     if(realurl.indexOf("?") == -1){
        //         realurl += "?";
        //     }else{
        //         realurl += "&";
        //     }
        //     realurl += encodeURIComponent(urldata);
        // }
        return this.httpsend(url, null, cbRes, cbErr, 'GET', false, '', null, retrycount);
    }

    httpPost(url, postdata, cbRes, cbErr, retrycount){
        return this.httpsend(url, postdata, cbRes, cbErr, 'POST', false, '', null, retrycount);
    }

    httpsend(url, urldata, cbRes, cbErr, smethod, isretry, contentType, options, retrycount){
        if(this._runningcount < this._maxrunning){
            return this._httpsend(url, urldata, cbRes, cbErr, smethod, isretry, contentType, options, retrycount);
        }else{
            console.log("[http]running/max:"+this._runningcount+"/"+this._maxrunning);
            console.log("[http]url:"+url);
            if(!isretry){
                let obj = {
                    u: url,
                    v: urldata,
                    successcb: cbRes,
                    errcb: cbErr,
                    ct_type: contentType,
                    opt: options,
                    rt_max: retrycount? retrycount: this._retrycount,
                    rt_inv: this._retryms
                };
                this.cachemsg.push(obj);
                return null;
            }
        }
    }

    _httpsend(url, urldata, cbRes, cbErr, smethod, isretry, contentType, options, retrycount){
        if(typeof(wx) != 'undefined' && wx.request){
            return this._wxRequest(url, urldata, cbRes, cbErr, smethod, isretry, contentType, options || {}, retrycount);
        }else if(typeof(XMLHttpRequest) != 'undefined'){
            return this._webRequest(url,urldata, cbRes, cbErr, smethod, isretry, contentType, options || {}, retrycount);
        }
        return null;
    }

    _wxRequest(url, urldata, cbRes, cbErr, smethod, isretry, contentType, options, retrycount){
        this._runningcount++;
        let self = this;
        var jsobj = urldata? JSON.parse(urldata): null;
        var ct = contentType || 'application/json';
        var responseType = options.responseType || 'text';
        var dataType = options.responseType || 'text';
        var tosec = options.timeout || 0;
        var xhr = wx.request({
            url: url,
            data: jsobj,
            dataType: dataType,
            method: smethod,
            timeout: tosec,
            responseType: responseType,
            header: {
                'content-type': ct,
                'Cache-Control':'no-cache'
            },
            success: function(res){
                //console.log("[wx]request success!" + res.statusCode);
                if(res.statusCode >= 200 && res.statusCode < 400) {
                    if (options.responseType === 'arraybuffer') {
                        self._parseZipData(res.data, options.originName, function (text) {
                            try{
                                cbRes && cbRes(text);
                            }catch(e){

                            }
                        }, function (err) {
                            try{
                                cbErr && cbErr(res.statusCode, err);
                            }catch(e){

                            }
                        })
                    } else {
                        // var restext = JSON.stringify(res.data);
                        cbRes && cbRes(res.data);
                    }
                }else{
                    if(!isretry && self._needretry){
                        let obj = {
                            u: url,
                            v: urldata,
                            successcb: cbRes,
                            errcb: cbErr,
                            ct_type: contentType,
                            opt: options,
                            rt_max: retrycount? retrycount: self._retrycount,
                            rt_inv: self._retryms
                        };
                        self.cachemsg.push(obj);
                    }else{
                        try{
                            cbErr && cbErr(res.statusCode, res.msg);
                        }catch(e){

                        }
                    }
                }
            },
            fail: function(res){
                console.log("[wx]request fail!"+ JSON.stringify(res));
                if(!isretry && self._needretry){
                    let obj = {
                        u: url,
                        v: urldata,
                        successcb: cbRes,
                        errcb: cbErr,
                        ct_type: contentType,
                        opt: options,
                        rt_max: retrycount? retrycount: self._retrycount,
                        rt_inv: self._retryms
                    };
                    self.cachemsg.push(obj);
                }else{
                    try{
                        cbErr && cbErr(-1, res? res.msg: '');
                    }catch(e){

                    }
                }
                // cbErr && cbErr(-1, res.msg);
            },
            complete: function(){
                self._runningcount--;
                //console.log("[wx]request complete!");
            }
          });
          return xhr;
    }

    _webRequest(url, urldata, cbRes, cbErr, smethod, isretry, contentType, options, retrycount){
        this._runningcount++;
        let self = this;
        let iserr = false;
        let orginurl = url;
        url += url.indexOf('?') >=0 ? '&__t=' + Date.now() : '?__t=' + Date.now();
        var xhr = new XMLHttpRequest();
        // xhr.responseType = "arraybuffer";
        xhr.responseType = options.responseType || 'text';
        xhr.timeout = options.timeout || 0;
        xhr.onreadystatechange = function () {
            // cc.log('xhr.onreadystatechange:' + xhr.readyState + '|' + xhr.status + '|' + url);
            if (xhr.readyState == 4){
                self._runningcount--;
                if(xhr.status >= 200 && xhr.status < 400) {
                    var contentType = xhr.getResponseHeader('content-type');
                    if (options.responseType === 'arraybuffer' && contentType && contentType === 'application/zip') {
                        self._parseZipData(xhr.response, options.originName, function (text) {
                            try{
                                cbRes && cbRes(text);
                            }catch(e){

                            }

                        }, function (err) {
                            try{
                                cbErr && cbErr(xhr.status, err);
                            }catch(e){

                            }
                        })
                    } else {
                        var response = xhr.responseText;
                        try{
                            cbRes && cbRes(response);
                        }catch(e){

                        }

                    }

                }else{
                    if(!isretry && self._needretry){
                        let obj = {
                            u: orginurl,
                            v: urldata,
                            successcb: cbRes,
                            errcb: cbErr,
                            ct_type: contentType,
                            opt: options,
                            rt_max: retrycount? retrycount: self._retrycount,
                            rt_inv: self._retryms
                        };
                        self.cachemsg.push(obj);
                    }else{
                        try{
                            cbErr && cbErr(xhr.status, xhr.statusText);
                        }catch(e){

                        }

                    }
                }
            }
        };
        // xhr.onabort = function(){
        //     self._runningcount--;
        // };
        xhr.onerror = function(){
            console.log('xhr.onerror' + '|' + url);
            // console.log(url);
            if(!iserr){
                iserr = true;
                self._runningcount--;
            }
        };
        xhr.ontimeout = function(){
            console.log('xhr.ontimeout' + '|' + url);
            // console.log(url);
            if(!iserr){
                iserr = true;
                self._runningcount--;
            }
        };
        xhr.open(smethod, url, true);
        (contentType) && xhr.setRequestHeader('content-type', contentType);
        xhr.send(urldata);
        return xhr;
    }

    _retry(){
        if(this.cachemsg.length > 0){
            this.cachemsg.forEach(element => {
                let obj = element;
                if(obj.retrying){
                    return;
                }
                let bneedretry = false;
                if(!obj.retry_count){
                    obj.retry_count = 1;
                    obj.passtime = 0;
                }
                obj.passtime += this._retryms;
                bneedretry = (obj.passtime >= obj.retry_count * obj.rt_inv);

                if(bneedretry && !obj.retrying){
                    obj.retrying = true;
                    let method = obj.v? 'POST': 'GET';
                    this.httpsend(obj.u, obj.v, (restext) => {
                        let idx = this.cachemsg.findIndex((element) => {
                            return element == obj;
                        });
                        if(idx != -1){
                            this.cachemsg.splice(idx, 1);
                        }
                        try{
                            obj.successcb && obj.successcb(restext);
                        }catch(e){

                        }

                    }, (errcode, errmsg) => {
                        obj.retrying = false;
                        obj.passtime = 0;
                        obj.retry_count++;
                        if(obj.retry_count >= obj.rt_max){
                            let idx = this.cachemsg.findIndex((element) => {
                                return element == obj;
                            });
                            if(idx != -1){
                                this.cachemsg.splice(idx, 1);
                            }
                            try{
                                obj.errcb && obj.errcb(errcode, errmsg);
                            }catch(e){

                            }
                        }
                    }, method, true, obj.ct_type, obj.opt, obj.rt_max);
                }

            });
        }
    }

    setRetryCount(count){
        this.retrycount = count;
    }

    setRetryInterval(millsec){
        if(millsec != this._retryms){
            this._retryms = millsec;
            if(this._retry_tid){
                clearInterval(this._retry_tid);
                this._retry_tid = 0;
            }
        }
        if(!this._retry_tid){
            this._retry_tid = setInterval(this._retry.bind(this), this._retryms);
        }
    }

    setNeedRetry(needretry){
        this._needretry = needretry;
        // if(!this._needretry && this._retry_tid){
        //     clearInterval(this._retry_tid);
        //     this._retry_tid = 0;
        // }else if(this._needretry && !this._retry_tid){
        //     this._retry_tid = setInterval(this._retry.bind(this), this._retryms);
        // }
    }

    _parseZipData(resData, fileName, scb, fcb) {
        jszip.loadAsync(resData)
          .then(data => {
              if (!fileName) {
                  for (let x in data.files) {
                      if (data.files[x]) {
                          fileName = x;
                          break;
                      }
                  }
              }
              if (fileName && data.file(fileName)) {
                  data.file(fileName).async("text").then((gamedt)=>{
                      try{
                        scb && scb(gamedt);
                      }catch(e){

                      }

                  }).catch(err => {
                      try{
                        fcb && fcb(err);
                      }catch(e){

                      }
                  })
              } else {
                  fcb && fcb('can not fetch file name');
              }
          })
          .catch(err => {
              console.error(err);
              try{
                fcb && fcb(err);
              }catch(e){

              }
          })
    }
}

module.exports = HttpCli;
