
var httpcli = require('./httpcli');

let httpclient = {
    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    // start () {},

    // update (dt) {},
    getInstance(){
        if(!this._instance){
            this._instance = new httpcli();
            this._instance.setRetryInterval(3000);
            this._instance.setNeedRetry(true);
        }
        return this._instance;
    },
    /**
     * 如果要请求zip格式的数据， 请设置options: {responseType: 'arraybuffer'},
     * 如果zip文件中有多个文件， 须设置 options.originName, 指定需要处理的文件名
     */
    httpGet(url, cbRes, cbErr, options, retrycount){
        // var realurl = url;
        // if(urldata){
        //     if(realurl.indexOf("?") == -1){
        //         realurl += "?";
        //     }else{
        //         realurl += "&";
        //     }
        //     realurl += encodeURIComponent(urldata);
        // }
        return this.httpsend(url, null, cbRes, cbErr, 'GET', '', options, retrycount);
    },

    httpPost(url, postdata, cbRes, cbErr, contentType, options, retrycount){
        return this.httpsend(url, postdata, cbRes, cbErr, 'POST', contentType, options);
    },

    httpsend(url, urldata, cbRes, cbErr, smethod, contentType, options, retrycount){
        options = options || {};
        return this.getInstance().httpsend(url, urldata, cbRes, cbErr, smethod, false, contentType, options, retrycount);
    },

    JSON_parse(text){
        try{
            return JSON.parse(text);
        }catch(err){
            console.log(err);
            return null;
        }
    }
};

module.exports = httpclient;
