// Type definitions for ./src/common/notification.js
// Project: [LIBRARY_URL_HERE] 
// Definitions by: [YOUR_NAME_HERE] <[YOUR_URL_HERE]> 
// Definitions: https://github.com/borisyankov/DefinitelyTyped
declare namespace notification{
	// notification._signals.<i>
	
	/**
	 * find signal
	 */
	interface _signalsI {
				
		/**
		 * 
		 */
		event : number;
	}
}
declare namespace notification._cachebinds{
	// notification._cachebinds.<i>.<i>
	
	/**
	 * 
	 */
	interface _cachebindsII {
	}
}

/**
 * 
 */
declare namespace notification{
		
	/**
	 * 
	 */
	export var _signals : Array</* notification._signalsI */ any>;
	
	/**
	 * 
	 */
	namespace _cachebinds{
	}
		
	/**
	 * 
	 * @param eEvent 
	 * @return  
	 */
	function _findSignal(eEvent : number): /* notification._signals.<i> */ any;
		
	/**
	 * 创建一个信号与监听函数的绑定
	 * @param {Number} [eEvent] 事件id（也可使用字符串）。
	 * @param {Function} [fnListener] 信号处理函数.
	 * @param {Object} [oTarget] 信号处理函数的对象。
	 * @return {Object} 返回一个描述信号与处理函数的绑定对象，作为移除绑定的句柄使用。
	 * @param eEvent? 
	 * @param fnListener? 
	 * @param oTarget? 
	 * @return  
	 */
	function createBinding(eEvent? : number, fnListener? : Function, oTarget? : any): any;
		
	/**
	 * 移除信号的绑定函数
	 * @param {Object|Array} [oBinding] createSignalBinding返回的对象。
	 * @param oBinding? 
	 */
	function removeBinding(oBinding? : {} | Array<any>): void;
		
	/**
	 * 监听事件
	 * 与createBinding功能一致(增加了缓存，方便删除)
	 * @param eEvent 
	 * @param fnListener 
	 * @param oTarget 
	 * @return  
	 */
	function on(eEvent : any, fnListener : any, oTarget : any): any;
		
	/**
	 * 取消监听事件（参数必须与监听事件保持一致）
	 * @param eEvent 
	 * @param fnListener 
	 * @param oTarget 
	 */
	function off(eEvent : any, fnListener : any, oTarget : any): void;
		
	/**
	 * 发送信号
	 * @param {Number} [eEvent] 事件id。
	 * @param eEvent? 
	 */
	function emit(eEvent? : number): void;
}
