let eventList = {};

const Events = Object.freeze({
  RECEIVE_AWARD: 'receive_award',
  RECEIVE_INVITE_AWARD: 'receive_invite_award',
  RECEIVE_ONLINE_AWARD: 'receive_online_award',
  RECEIVE_SIGN_AWARD: 'receive_sign_award',
  SIGN_FEEDBACK: 'sign_feedback',
  RECEIVE_BOOKMARK_AWARD: 'receive_bookmark_award',
  RECEIVE_WXKF_AWARD: 'receive_wxkf_award',
  VOICE_RECOVER: 'voice_recover',
  LAYER_SHOW: 'jclayer_show',
  LAYER_CLOSE: 'jclayer_close',
  BANNER_RESHOW: 'banner_reshow',
  APP_SHOW: 'jcapp_show',
  APP_HIDE: 'jcapp_hide',
  AD_VIDEO_LIMITED: 'advideo_limited',
  RECEIVE_LUCKY_AWARD: 'receive_lucky_award',
  LUCKY_FEEDBACK: 'lucky_feedback',
  AD_VIDEO_CLOSED: 'advideo_closed', // 视频关闭(微信上也要处理背景音乐)
  AUDIO_INTERRUPT_BEGIN: 'audio_interrupt_begin', // 音频中断开始
  AUDIO_INTERRUPT_END: 'audio_interrupt_end', // 音频中断结束
  RECORD_START: 'record_start', //录屏开始
  RECORD_STOP: 'record_stop', //录屏结束
  RECORD_ERROR: 'record_error', //录屏出错
  RECORD_PAUSE: 'record_pause', //录屏暂停
  RECORD_RESUME: 'record_resume', //录屏恢复
  RECORD_FEEDBACK: 'record_feedback', //录屏反馈tips
  RECORD_SHARE_FEEDBACK: 'record_share_feedback', //录屏分享反馈
  GOTO_APP_RESULT: 'goto_app_result', //跳转结果通知
  PROMOTION_DATA_READY: 'promotion_data_ready', // 推广系统获取数据成功
  PROMOTION_PANEL_CLOSED: 'promotion_panel_closed', // 推广系统弹出层关闭事件
  PROMOTION_PANEL_OPEN: 'promotion_panel_open', // 推广系统弹出层开启事件
  GOODS_EXCHANGE_BUY: 'goods_exchange_buy', //实物兑换外部统一购买事件
  GOODS_EXCHANGE_SELECTED_UPDATE: 'goods_exchange_selected_update', //实物兑换选中更新事件
  GOODS_EXCHANGE_SUCCESS: 'goods_exchange_success', //实物兑换成功事件

  BANNER_MANUAL_SHOW: 'banner_manual_show', // banner统一处理事件（显示）
  BANNER_MANUAL_HIDE: 'banner_manual_hide', // banner统一处理事件（隐藏）

  PAY_SUCCESS:            'pay_success',            // 支付成功
  PAY_FAILED:             'pay_failed',             // 支付失败
  PAY_CANCEL:             'pay_cancel',             // 支付取消
  PURCHASE_RESTORED:      'purchase_restored',      // 恢复购买
  REFRESH_PRODUCT_SUCCESS:'refresh_product_success',// 刷新产品信息成功
  REFRESH_PRODUCT_FAILED: 'refresh_product_failed', // 刷新产品信息失败

  FORCE_OFF_LINE: 'force_off_line', //强制下线

  USER_MONEY_UPDATE: 'user_money_update', //用户金币更新事件
  AVATAR_UPDATE: 'avatar_update', // 服装更新
});

export default {
  on(name, self, cb) {
    let cbArr = eventList[name];
    if (Array.isArray(cbArr)) {
      cbArr.push({
        self,
        cb
      })
    } else {
      eventList[name] = [{
        self,
        cb
      }]
    }
  },
  remove(name, target) {
    let cbArr = eventList[name];
    if (Array.isArray(cbArr)) {
      eventList[name] = cbArr.filter(({
        self,
        cb
      }) => {
        return target !== self
      })
    }
  },
  emit(name, data, issinglecall) {
    let cbArr = eventList[name];
    if (Array.isArray(cbArr)) {
      if (issinglecall && cbArr.length > 0) {
        let obj = cbArr[cbArr.length - 1];
        obj && obj.cb && obj.cb.call(obj.self, data);
      } else {
        cbArr.map(({
          self,
          cb
        }) => {
          cb.call(self, data)
        });
      }

    }
  },
  find(name) {
    return eventList[name] != null;
  },
  Events: Events
}
