var AdObj = function (type) {
  this.type = type;
  this.onResize = function () {
  }
  this.showBanner = function () {
    jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'showBanner', '()V');
  }
  this.hideBanner = function () {
    jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'hideBanner', '()V');
  }
  this.showRewardVideo = function () {
    cc.currentVideoAd = this;
    console.log('showRewardVideo ', cc.currentVideoAd);
    jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'showRewardVideo', '()V');
  }
  this.showInterstitial = function () {
    jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'showInterstitial', '()V');
  }
  this.showActArr = [this.showBanner, this.showRewardVideo, this.showInterstitial];
  this.hideActArr = [this.hideBanner, this.hideBanner, this.hideBanner];
  this.show = function () {
    return new Promise((resolve, reject) => {
      this.showActArr[this.type].call(this);
      resolve && resolve();
    });
  }
  this.hide = function () {
    this.hideActArr[this.type].call(this);
  }
}
/**
 * 支付相关
 * @class
 */
var PayObj = function() {
  sdkbox.IAP.setListener({
    onSuccess: function (product) {
      //Purchase success
      console.log('[IAP]Purchase success:' + JSON.stringify(product));
      if (this.purchaseSuccessCb) {
        this.purchaseSuccessCb(product);
      } else {
        cc.jc.event.emit(cc.jc.event.Events.PAY_SUCCESS, product);
      }
    },
    onFailure: function (product, msg) {
      //Purchase failed
      //msg is the error message
      console.log('[IAP]Purchase failed:' + JSON.stringify(product) + '' + msg);
      if (this.purchaseFailCb) {
        this.purchaseFailCb({product, errmsg: msg, errcode: 2});
      } else {
        cc.jc.event.emit(cc.jc.event.Events.PAY_FAILED, {product, msg});
      }
    },
    onCanceled: function (product) {
      //Purchase was canceled by user
      console.log('[IAP]Purchase canceled:' + JSON.stringify(product));
      if (this.purchaseFailCb) {
        this.purchaseFailCb({product, errmsg: 'user cancel', errcode: 1});
      } else {
        cc.jc.event.emit(cc.jc.event.Events.PAY_CANCEL, product);
      }
    },
    /**
     * 恢复已购买商品
     * 如果用户购买多次, 将多次触发
     * @param product
     */
    onRestored: function (product) {
      console.log('[IAP]Purchase restored:' + JSON.stringify(product));
      cc.jc.event.emit(cc.jc.event.Events.PURCHASE_RESTORED, product);
    },
    onProductRequestSuccess: function (products) {
      //Returns you the data for all the iap products
      this.productList = products;
      console.log('[IAP]iap products:' + JSON.stringify(products));
      if (this.refreshSuccessCb) {
        this.refreshSuccessCb(products);
      } else {
        cc.jc.event.emit(cc.jc.event.Events.REFRESH_PRODUCT_SUCCESS, products);
      }
    },

    onProductRequestFailure: function (msg) {
      //When product refresh request fails.
      console.log('[IAP]product refresh request fails:' + msg);
      if (this.refreshFailCb) {
        this.refreshFailCb(msg);
      } else {
        cc.jc.event.emit(cc.jc.event.Events.REFRESH_PRODUCT_SUCCESS, msg);
      }
    }
  });
  sdkbox.IAP.init();
  sdkbox.IAP.setDebug(true);
  sdkbox.IAP.refresh();
  /**
   * 购买
   * @param {string} productName  从productList中获取的产品名
   * @param {PayObj~purchaseSuccessCb} successCb    支付成功回调, 如果为空的话, 支付成功后, 会emit PAY_SUCCESS事件
   * @param {PayObj~purchaseFailCb} failCb       支付失败回调, 如果为空的话, 支付失败后, 会emit PAY_FAILED事件
   * */
  this.purchase = function(productName, successCb, failCb) {
    console.log('[IAP] begin purchase: ', productName);
    this.purchaseSuccessCb = successCb;
    this.purchaseFailCb = failCb;
    sdkbox.IAP.purchase(productName);
  }
  /**
   * @callback PayObj~purchaseSuccessCb
   * @param {Object} product
   */
  /**
   * @callback PayObj~purchaseFailCb
   * @param {number} data.errcode 错误代码 1: 用户取消, 2: 其他
   * @param {Object} data.product 购买的商品
   * @param {string} data.errmsg  服务返回的错误信息
   */

  /**
   * 恢复购买
   */
  this.restore = function() {
    sdkbox.IAP.restore();
  }

  /**
   * 主动刷新产品信息
   * @param {PayObj~refreshSuccessCb} successCb
   * @param {PayObj~refreshFailCb} failCb
   */
  this.refresh = function(successCb, failCb) {
    this.refreshSuccessCb = successCb;
    this.refreshFailCb = failCb;
    sdkbox.IAP.refresh();
  }

  /**
   * @callback PayObj~refreshSuccessCb
   * @param {Object} products 最新的产品信息
   */
  /**
   * @callback PayObj~refreshFailCb
   * @param {string} msg 服务返回的错误信息
   */
}
var PLAT_ANDROID = {
  SHARE_FAIL: 20,
  SHARE_TIME: 3000,
  shareCount: {},

  getLaunchInfo() {
    return null;
  },

  getSystemInfo() {
    return null;
  },

  /** example:
   *
   * @param {object} btninfo :
   *  {
   *      width: 100,
   *      height: 100,
   *      name: logo.png
   * }
   * @param {function} cb
   */
  getUserInfo(btninfo, cb) {

  },

  destoryAuth() {

  },

  setUserInfo(dstinfo, ptinfo) {
    dstinfo.nickname = ptinfo.nickName;
    dstinfo.country = ptinfo.country;
    dstinfo.province = ptinfo.province;
    dstinfo.city = ptinfo.city;
    dstinfo.avatar_url = ptinfo.avatarUrl;
    dstinfo.sex = ptinfo.gender;
  },

  setTokenInfo(dstinfo, tokeninfo) {
    if (tokeninfo && tokeninfo.rawData) {
      dstinfo.rawData = tokeninfo.rawData;
      dstinfo.signature = tokeninfo.signature;
      dstinfo.encryptedData = tokeninfo.encryptedData;
      dstinfo.iv = tokeninfo.iv;
    }
  },

  init(owner, channelid) {
    this._owner = owner;
    this._ptid = channelid;
    cc.videoClose = function (isEnd) {
      console.log('video ad close, isEnd:', isEnd, cc.currentVideoAd);
      if (cc.currentVideoAd) {
        cc.currentVideoAd.onClose && cc.currentVideoAd.onClose(isEnd);
        cc.currentVideoAd = null;
      }
    }
    this.pay = null;
    // this.pay = new PayObj();
  },

  bindController(ctrl) {
    this._man = ctrl;
    let nd = cc.find('Canvas');
    if (nd) {
      let cv = nd.getComponent(cc.Canvas);
      if (cv) {
        this._dr = cv.designResolution;
      }
    }
  },

  commonShare(aimg, atitle, stype, param, successcb, failcb, exinfo) {

  },

  captureShare(rc, title, stype, param, successcb, failcb, exinfo) {

  },


  PTInitShare(normalinfo) {


  },

  PTShare(content, imgurl, param, successcb, failcb) {

  },

  PTShareCapture(content, rc, param, successcb, failcb) {

  },

  PTOpenKF(cb, info) {
    cb && cb(false);
  },

  /**
   * @param {string} str 显示的文字
   * @param {icon} icon 图标类型 这里不作处理
   * */
  PTShowToast(str, icon) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID && str) {
      jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'showToast', '(Ljava/lang/String;)V', str);
    }
  },

  PTGotoApp(appid, apppath, exobj, cb, qdid, env, acontent) {
    cb && cb(-1000, null);
  },

  PTLogin(info, successcb, failcb) {
    var self = this;
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      // var config = new gpg.PlatformConfiguration();
      // new gpg.GameServices.Builder()
      //   .SetOnAuthActionStarted( function( result ) {
      //     // Auth started callback
      //     console.log('auth start:', JSON.stringify(result));
      //   })
      //   .SetOnAuthActionFinished( function( result ) {
      //     // Auth finished callback
      //     console.log('auth finished:', JSON.stringify(result));
      //     gpg.GameServices.Players.FetchSelf
      //     successcb && successcb();
      //   })
      //   .SetLogging( gpg.LogLevel.VERBOSE )    // Set Logging level
      //   .EnableSnapshots()                  // Enable Snapshot (Saved Game) functionailty
      //   .Create(function( game_services ) {
      //     game_services.StartAuthorizationUI();
      //   }, config);
      var uid = jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'generateUid', '()Ljava/lang/String;');
      self._owner.setNickName(uid.length>7 ? uid.substring(0, 7) : uid);
      console.log('[jcfw] success get uid: ', uid);
      self._owner.login.login(uid, successcb, failcb, uid);
    } else {
      failcb && failcb(0, -1000, 'not android platform!');
    }
  },


  //广告相关
  PTInitADService() {

  },


  PTCreateBannerAD(adid, st) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      return new AdObj(0);
    } else {
      return null;
    }
  },

  PTCreateVideoAD(adid) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      return new AdObj(1);
    } else {
      return null;
    }
  },

  PTCreateInsertAD(adid) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      return new AdObj(2);
    } else {
      return null;
    }
  },

  PTSetVideoADCallback(adobj, adowner, cb) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      adobj.onClose  = function (res) {
        console.log('[ad]onClose:' + JSON.stringify(res));
        // 用户点击了【关闭广告】按钮
        if (res) {
          // 正常播放结束，可以下发游戏奖励
          cb && cb(true, adowner, res);
        } else {
          // 播放中途退出，不下发游戏奖励
          cb && cb(false, adowner, res);
        }
        // ad.offClose && ad.offClose(closeCb);
      };

    }
  },

  PTVibrateShort(successcb, failcb) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'vibrate', '(I)V', 0);
      successcb && successcb();
    } else {
      failcb && failcb();
    }
  },

  PTVibrateLong(successcb, failcb) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      jsb.reflection.callStaticMethod('com/jc/jcfw/JcSDK', 'vibrate', '(I)V', 1);
      successcb && successcb();
    } else {
      failcb && failcb();
    }
  },

  PTOpenDataContext() {
    return null;
  },

  PTADWatch(adid, successcb, failcb) {
    if (cc.sys.isNative && cc.sys.os === cc.sys.OS_ANDROID) {
      let videoAd = this.PTCreateInsertAD(adid);
      videoAd.onClose = function (res) {
        console.log('[ad]onClose:' + JSON.stringify(res));
        // 用户点击了【关闭广告】按钮
        if (res) {
          // 正常播放结束，可以下发游戏奖励
          successcb&&successcb(adid, res, adid);
        } else {
          // 播放中途退出，不下发游戏奖励
          failcb && failcb(adid, res, true, adid);
        }
        // ad.offClose && ad.offClose(closeCb);
      };
      videoAd.show();

    } else {
      failcb && failcb(adid, -1000, true, adid);
    }
  }
};

module.exports = PLAT_ANDROID;
