var jcAD = {
    _calcBannerWidth(bannerwidth){
        let adw = bannerwidth? bannerwidth: this.winW;
        let maxw = this.owner.plat.PTBannerADMaxWidth? this.owner.plat.PTBannerADMaxWidth(): this.winW;
        if(adw<=0 || adw > maxw){
            adw = maxw;
        }
        return adw;
    },

    __createAD: function(adtype, adunitid, bannerHV, owner, bannerY, bannerW){
        let obj = owner;
        if(!owner){
            obj = {
                adType: adtype,
                adUnitId: adunitid,
                state: 0,
                hide: function(){
                    this.ad && this.ad.hide && this.ad.hide();
                }
            };
        }
        if(adtype == 0){
            let adw = this._calcBannerWidth(bannerW);
            let height = cc.jc.channelID === cc.jc.channel.QQ_MINI ? adw / 4.12 : 125;
            let nhv = bannerHV? bannerHV: height;
            let padding = this.winH / this.winW >= 2 ? 20 : 0;
            let realy = (typeof(bannerY) == 'number' && bannerY>=0)? bannerY: this.winH - nhv - padding;
            let adl = (this.winW - adw)/2;
            let st = null;
            if(!obj.style){
                st = {
                    left: adl,
                    top: realy,
                    width: adw,
                    height: nhv,
                    x: adl,
                    y: realy
                };
                obj.style = st;
            }else{
                st = obj.style;
            }

            obj.ad = this.owner.plat.PTCreateBannerAD(adunitid, st);
        }else if(adtype == 1){
            obj.ad = this.owner.plat.PTCreateVideoAD(adunitid);
        }else if(adtype == 2){
            obj.ad = this.owner.plat.PTCreateInsertAD(adunitid);
        }

        return obj;
    },

    init(channelid, gameid, isoffical, owner, adparam){
        this.owner = owner;
        this.gameid = gameid;
        this.channelid = channelid;
        this.BannerAds = [];
        this.InsertAds = [];
        this.VideoAds = [];
        this.cleanBannerAD();
        this.cleanVideoAD();
        this.owner && this.owner.plat && this.owner.plat.PTInitADService(adparam);
    },

    setAccountID(accountid, sessionid){
        this.accountid = accountid;
        this.sessionid = sessionid;
    },

    setNickName(nickname){
        this.nickname = nickname;
    },

    setFromAppID(appid){
        this.fromid = appid;
    },

    setLocalUUID(uuid){
        this.localid = uuid;
    },

    setSystemInfo(info){
        let sz = cc.winSize;
        this.winW = info && info.windowWidth? info.windowWidth: sz.width;
        this.winH = info && info.windowHeight? info.windowHeight: sz.height;
        console.log('[ad]win:'+this.winW + "|" + this.winH);
        this._dtLineH = 0;
        if(info && info.statusBarHeight){
            this._dtLineH = info.statusBarHeight > 30? 30: 0;
        }
    },

    // 添加banner广告
    addBannerAD(advid, identifier, bannerHValue, rspCb){
        var adobj = this.__createAD(0, advid, bannerHValue);
        if(adobj){
            adobj.param = identifier;
            adobj.rspCb = rspCb;
            this.initAD(adobj);
            this.BannerAds.push(adobj);
        }
        return adobj;
    },

    // 添加插屏广告
    addInsertAD(advid, identifier){
        var adobj = this.__createAD(2, advid);
        if(adobj){
            adobj.param = identifier;
            adobj.rspCb = rspCb;
            this.initAD(adobj);
            this.InsertAds.push(adobj);
        }
        return adobj;
    },

    // 添加激励广告（视频广告）
    addVideoAD(advid, identifier, rspCb){
        var adobj = this.__createAD(1, advid);
        if(!adobj){
            return null;
        }
        var owner = this.findVideoOwner(adobj.ad);
        if(owner){
            owner.param = identifier;
            owner.rspCb = rspCb;
            return owner;
        }
        adobj.param = identifier;
        adobj.rspCb = rspCb;
        this.initAD(adobj);
        this.VideoAds.push(adobj);
        return adobj;
    },

    reLoadBannerAD(identifier, advid){
        let obj = this.findBannerAD(identifier);

        let bfinded = (obj != null) && (obj != undefined);

        if(!obj && advid){
            obj = this.addBannerAD(advid, identifier, 0, null);
        }

        if(bfinded && obj && obj.ad){
            let id = obj.adUnitId;
            if(id){
                this.destoryAD(obj.ad);
                obj.adloaded = false;
                var adobj = this.__createAD(0, id, 0, obj);
                if(adobj){
                    this.initAD(adobj);
                }
            }
        }
        return obj;
    },

    hasBannerAD(identifier){
        let obj = this.findBannerAD(identifier);
        if(obj && obj.ad){
            return true;
        }
        return false;
    },

    hasVideoAD(identifier){
        let obj = this.findVideoAD(identifier);
        if(obj && obj.ad){
            return true;
        }
        return false;
    },

    findBannerAD(identifier){
        let obj = this.BannerAds.find((element) => {
            return element.param == identifier;
        })
        return obj;
    },

    findInsertAD(identifier){
        let obj = this.InsertAds.find((element) => {
            return element.param == identifier;
        })
        return obj;
    },

    randomBannerAD(){
        if(this.BannerAds.length == 0){
            return null;
        }
        let n = Math.floor(Math.random() * this.BannerAds.length);
        return this.BannerAds[n];
    },

    findVideoAD(identifier){
        let obj = this.VideoAds.find((element) => {
            return element.param == identifier;
        })
        return obj;
    },

    findVideoOwner(ad){
        let obj = this.VideoAds.find((element) => {
            return element.ad == ad;
        })
        return obj;
    },

    hideAllAD(){
        this.BannerAds.forEach(element => {
            this.hideAD(element);
        });
    },

    needLoadBannerAD(){
        return this.owner.plat.PTBannerNeedLoad? this.owner.plat.PTBannerNeedLoad(): false;
    },

    // 显示/隐藏banner广告
    switchBannerAD (identifier, bShow, successcb, failcb, breload){
        this.hideAllAD();

        if(bShow){
            let obj = null;
            let param = identifier;
            let isrefresh = breload;
            if(!identifier){
                obj = this.randomBannerAD();
                param = obj.param;
            }else{
                obj = this.findBannerAD(identifier);
                if(!obj){
                    obj = this.addBannerAD(identifier, identifier, 0, null);
                    isrefresh = true;
                }
            }
            if(obj){
                // let isaudit = this.owner && this.owner.isVerify;
                // if(!isaudit){
                //     let needreload = false;
                //     if(obj.adloaded){
                //         let dt = new Date().getTime() - obj.adloadtime;
                //         if(dt >= 50000){
                //             needreload = true;
                //         }
                //     }
                //     if(needreload){
                //         let newobj = this.reLoadBannerAD(param);
                //         if(newobj){
                //             obj = newobj;
                //         }
                //     }
                // }
                if(breload){
                    obj = this.reLoadBannerAD(identifier, obj.adUnitId);
                }
                let bneedload = this.needLoadBannerAD();
                if(bneedload && !obj.adloaded){
                    obj.loadcb = loadcb;
                    obj.successcb = successcb;
                    obj.needshow = true;
                }else{
                    this.showAD(obj, successcb, failcb, isrefresh);
                }

                return obj.adUnitId;
            }
        }
        return '';
    },

    simpleBannerADShow(adid, adh, ady, successcb, failcb, loadcb, adw){
        let obj = this.__createAD(0, adid, adh, null, ady, adw);
        if(obj && obj.ad){
            obj.param = adid;
            obj.loadcb = loadcb;
            obj.successcb = successcb;
            obj.failcb = failcb;
            this.initAD(obj);
            let bneedload = this.needLoadBannerAD();
            if(bneedload && !obj.adloaded){
                obj.needshow = true;
            }else{
                this.showAD(obj, successcb, failcb);
            }
        }
        return obj;
    },

    simpleInsertADShow(adid, successcb, failcb){
        let obj = this.__createAD(2, adid);
        if(obj && obj.ad){
            this.initAD(obj);
            this.showAD(obj, successcb, failcb);
        }
        return obj;
    },

    destroyAllBannerAD(){
        this.BannerAds.forEach(element => {
            this.destroyObj(element);
        });
        this.BannerAds.length = 0;
    },

    showBannerAD(adid, successcb, failcb, loadcb, adwidth, oversec){
        let obj = null;
        if(!oversec || typeof(oversec)!="number"){
            this.destroyAllBannerAD();
        }else{
            this.hideAllAD();
            obj = this.findBannerAD(adid);
            if(obj && obj.adloaded){
                let dt = new Date().getTime() - obj.adloadtime;
                if(dt >= oversec*1000){
                    this.destroyObj(obj, true);
                    obj = null;
                }
            }
        }

        if(obj){
            let bneedload = this.needLoadBannerAD();
            if(bneedload && !obj.adloaded){
                obj.successcb = successcb;
                obj.failcb = failcb;
                obj.needshow = true;
            }else{
                this.showAD(obj, successcb, failcb);
            }
        }else{
            obj = this.simpleBannerADShow(adid, 0, -1, successcb, failcb, loadcb, adwidth);
            obj && this.BannerAds.push(obj);
        }
        return obj;
    },

    // 显示激励广告（视频广告）
    showRewardAD (identifier, successcb, failcb, loadcb, adid){
        let obj = this.findVideoAD(identifier);
        if(!obj && adid){
            obj = this.addVideoAD(adid, identifier, null);
        }
        if(!obj || !obj.ad){
            this.simpleRewardADShow(adid, identifier, successcb, failcb);
            return;
        }
        obj.successcb = successcb;
        obj.failcb = failcb;
        if(obj.adloaded){
            loadcb && loadcb(obj.param, null, obj.adUnitId);
            this.showAD(obj);
        }else{
            obj.loadcb = loadcb;
            obj.needshow = true;
            this.loadAD(obj);
        }

    },

    simpleRewardADShow(adid, adname, successcb, failcb){
        if(this.owner.plat.PTADWatch){
            this.owner.plat.PTADWatch(adid, successcb, failcb);
        }else{
            failcb && failcb(adname, null, true, adid);
        }
    },

    randomRewardADShow(adlst, adname, successcb, failcb, loadcb){
        if(adlst.length > 0){
            let idx = adlst.length === 1? 0: Math.floor(Math.random() * adlst.length);
            let adid = adlst[idx];
            this.showRewardAD(adid, successcb, failcb, loadcb, adid);
        }
    },

    onLoadAD(obj){
        console.log("[ad]onload");
        obj && console.log(obj.adUnitId);
        obj.adloaded = true;
        obj.adloadtime = new Date().getTime();
        obj.rspCb && obj.rspCb(100, obj);
        if(obj.loadcb){
            obj.loadcb(obj.param, null, obj.adUnitId);
            obj.loadcb = null;
        }
        if(obj.needshow){
            obj.needshow = false;
            if(obj.adType == 0){
                let successcb = obj.successcb;
                let failcb = obj.failcb;
                obj.successcb = null;
                obj.failcb = null;
                this.showAD(obj, successcb, failcb);
            }else{
                this.showAD(obj);
            }
        }
    },

    onErrAD(errtype, err, obj){
        console.log('[AD]err:' + errtype);
        console.log(err);
        obj.adloaded = false;
        obj.rspCb && obj.rspCb(errtype, obj, err);
        if(obj.failcb){
            obj.failcb(obj.param, err, true, obj.adUnitId);
            obj.failcb = null;
        }
    },

    onFinishAD(bReward, obj, res){
        if(bReward){
            obj.rspCb && obj.rspCb(10, obj, res, true);
            if(obj.successcb){
                obj.successcb(obj.param, res, obj.adUnitId);
                obj.successcb = null;
            }
        }else{
            obj.rspCb && obj.rspCb(11, obj, res, false);
            if(obj.failcb){
                obj.failcb(obj.param, res, false, obj.adUnitId);
                obj.failcb = null;
            }
        }
    },

    destoryAD(ad){
        if(!ad){
            return;
        }
        ad.state = 30;
        ad.destroy && ad.destroy();
    },

    destroyObj(obj, needremove){
        if(!obj){
            return;
        }
        if(needremove){
            for(let i = 0; i < this.BannerAds.length; i++){
                if(this.BannerAds[i] == obj){
                    this.BannerAds.splice(i, 1);
                    break;
                }
            }
        }
        obj.successcb = null;
        obj.failcb = null;
        obj.loadcb = null;
        obj.rspCb = null;
        this.destoryAD(obj.ad);
    },

    showAD(obj, successcb, failcb){
        let ad = obj.ad;
        if(!ad){
            return;
        }
        ad.state = 10;
        if(ad.show) {
            try{
                ad.show()
                  .then(()=>{
                      successcb && successcb(obj.param, null, obj.adUnitId);
                  })
                  .catch((error)=>{
                      console.log('[ad.show]error');
                      console.log(error);
                      obj.adloaded = false;
                      failcb && failcb(obj.param, error, true, obj.adUnitId);
                  });
            }
            catch(err){

            }
        }
    },

    hideAD(obj){
        let ad = obj.ad;
        if(!ad){
            return;
        }
        ad.state = 20;
        ad.hide && ad.hide();
    },

    // 激励广告调用
    loadAD(obj){
        let ad = obj.ad;
        if(!ad){
            return;
        }
        ad.state = 100;
        obj.adloaded = false;
        ad.load? ad.load(): this.onLoadAD(obj);
    },

    initAD(obj){
        let ad = obj.ad;
        let adtype = obj.adType;
        if(!ad){
            return;
        }
        ad.onLoad && ad.onLoad(() => {
            // console.log("[ad]onload");
            this.onLoadAD(obj);
        });
        ad.onError && ad.onError(res => {
            console.log("[ad]onerror:"+JSON.stringify(res));
            this.onErrAD(-obj.state, res, obj);
        });
        if(adtype == 0){
            ad.onResize(res => {
                if(res){
                    console.log("[bannerad]onResize:" + res.width + "," + res.height);
                    console.log(ad.style);
                    let nh = res.height? res.height: (res.width / 16 * 9);
                    let nt = this.winH - nh - this._dtLineH;
                    if(ad.style) {
                        if(nh > 0){
                            ad.style.top = nt;
                            ad.style.y = nt;
                        }
                        if(res.width > 0 && res.width != ad.style.width){
                            ad.style.left = (this.winW - res.width) / 2;
                            ad.style.x = ad.style.left;
                        }
                    }
                }
            });
        }else if(adtype == 1){
            this.owner.plat.PTSetVideoADCallback(ad, obj, this.onFinishAD);
        }
    },

    cleanBannerAD(){
        if(this.BannerAds.length > 0){
            this.BannerAds.forEach(element => {
                this.destoryAD(element.ad);
            });
            this.BannerAds.length = 0;
        }
    },

    cleanVideoAD(){
        if(this.VideoAds.length > 0){
            this.VideoAds.length = 0;
        }
    },
};

module.exports = jcAD;
