var strutils = require('../common/strutils');
var dateutils = require('../utils/dateutils');

const AD_SHARE_COMMON = 'ad_share_common';
var JCADShareCtrl = {
    KEY: 'platinfo',

    SHARE_FLAG: 1,
    AD_FLAG: 2,

    init(owner, isoffical){
        this._owner = owner;
        this._isoffical = isoffical;
    },

    loginOver(){
        this.loadInfo();
    },

    loadShareConfig(cfg){
        if(!this._rinfo){
            this._rinfo = {};
        }
        for(var i =0;i<cfg.length;i++){
            var sdt = cfg[i];
            let adid = sdt.ad_id;
            if(adid){
                sdt.adlst = adid.split(',');
            }
            if(!sdt.asqueue){
                sdt.asqueue = [];
            }
            if(sdt.ad_cd && typeof(sdt.ad_cd) == 'object' && sdt.ad_cd.reg){
                let lst = sdt.ad_cd.reg.split(',');
                lst.forEach(element => {
                   let ls = element.split('-');
                   if(ls.length >= 2){
                       let obj = {
                           is_share: (ls[0] == 'S') || (ls[0] == 's'),
                           maxcount: parseInt(ls[1])
                       };
                       sdt.asqueue.push(obj);
                   }
                });
            }
            this._rinfo[sdt.type] = sdt;
        }
        this._commonshareinfo = this.getShareInfo('normal');

        console.log("[loadShareConfig]");
        console.log(cfg);
    },

    _loadInfo(restext){
        let obj = null;
        try{
            if(restext){
                obj = JSON.parse(restext);
            }
        }catch(err){

        }
        if(obj){
            this._adshare = obj;
        }else if(!this._adshare){
            this._adshare = {};
        }
        this._loaded = true;
    },

    loadInfo(datastr){
        if(datastr){
            this._loadInfo(datastr);
            return;
        }

        this._owner && this._owner.ccstorage.getStorage(this.KEY, (restext)=>{
            console.log('[jcadsharectrl]loadinfo:' + restext);
            this._loadInfo(restext);
        }, (lerr, nerr, errmsg)=>{
            console.log('[jcadsharectrl]loadinfo failed:' + lerr + "|" + nerr + "|" + errmsg);
        });
    },

    saveInfo(){
        this._owner && this._owner.ccstorage.setStorage(this.KEY, JSON.stringify(this._adshare), ()=>{

        }, (lerr, nerr, errmsg)=>{

        }, 1);
    },

    getShareInfo(stype){
        let info = {
            imgurl: '',
            title: '',
            imgindex: -1,
        };
        if(!this._rinfo){
            return info;
        }
        let sdt = this._rinfo[stype];
        if(!sdt){
            sdt = this._rinfo['normal'];
        }
        if (sdt && sdt.images && sdt.images.length > 0) {
            let ite = strutils.randomInt(sdt.images.length-1);
            info.imgindex = ite;
            info.imgurl = sdt.images[ite];
            info.title = sdt.strs[ite];
        }
        return info;
    },

    AD_Share(stype, param, cb){
        if(!this._rinfo){
            cb && cb(false, -1, 0);
            return false;
        }

        let sdt = this._rinfo[stype];

        if(!sdt || sdt.ad_first == '4'){
            sdt = this._rinfo['adnormal'];
        }

        if(!sdt){
            cb && cb(false, -2, 0);
            return false;
        }

        let pro = this._adshare && this._adshare[stype];
        if(!pro){
            pro = {
                adcnt: 0,
                srcnt: 0,
            };
            this._adshare && (this._adshare[stype] = pro);
        }

        let isdiff = false;

        let isonlyshare = sdt.ad_first == '2';

        let isonlyad = sdt.ad_first == '3';

        let isShare = sdt.ad_first == '0' || isonlyshare;

        let isloop = (sdt.ad_first == '5') && sdt.asqueue && (sdt.asqueue.length > 0);

        let _checkloop = function(bnext){
            if(bnext){
                pro.curr++;
            }
            if(typeof(pro.curr) != 'number' || pro.curr >= sdt.asqueue.length){
                pro.curr = 0;
            }
            if(sdt.asqueue.length > pro.curr){
                let obj = sdt.asqueue[pro.curr];
                if(obj){
                    isShare = obj.is_share;
                    isShare? (sdt.share_count = obj.maxcount): (sdt.ad_count = obj.maxcount);
                    if(bnext){
                        pro.adcnt = 0;
                        pro.srcnt = 0;
                    }
                    return true;
                }
            }
            return false;
        }

        if(isloop){
            _checkloop();
        }

        if (!isShare) {
            if ( sdt.ad_count != 0) {
                let bok = pro.adcnt < sdt.ad_count;
                if(!bok && isloop){
                    if(_checkloop(true)){
                        bok = true;
                        isdiff = false;
                    }
                }
                if(!bok && !isShare){
                    if(isonlyad || sdt.share_count < 0 || sdt.srcnt >= sdt.share_count){
                        cb && cb(false, -20, 0);
                        return;
                    }else{
                        isShare = true;
                        isdiff = true;
                    }
                }
            }
        }

        if(isShare) {
            if (sdt.share_count != 0) {
                let bok = pro.srcnt < sdt.share_count;
                if(!bok && isloop){
                    if(_checkloop(true)){
                        bok = true;
                        isdiff = false;
                    }
                }
                if(!bok && isShare){
                    if (isonlyshare || sdt.ad_count < 0 || sdt.adcnt >= sdt.ad_count){
                        cb && cb(false, -10, 0);
                        return;
                    }else{
                        isShare = false;
                        isdiff = true;
                    }
                }
            }
        }

        let self = this;
        let shareMe = function () {
            let iconUrl = '';
            let sharetitle = '';
            let ite = 0;
            if (sdt.images.length > 0) {
                let brand = true;
                let idx = 0;
                if(param && typeof(param) == 'object' && typeof(param.shareindex) == 'number'){
                    idx = param.shareindex;
                    brand = false;
                }
                ite = brand? strutils.randomInt(sdt.images.length-1): idx;
                iconUrl = sdt.images[ite];
                sharetitle = sdt.strs[ite];

                if(param && typeof(param) == 'object' && typeof(param.titleparam) == 'object' &&
                    Object.prototype.toString.call(param.titleparam) === "[object Array]"){
                    sharetitle = sharetitle.format(param.titleparam);
                }
            }

            let bcapture = false;
            if(sdt.ad_cd && typeof(sdt.ad_cd) == 'object'){
                bcapture = sdt.ad_cd.iscapture;
            }
            if(bcapture){
                let rc = {
                    x: 0,
                    y: 0,
                    width: cc.winSize.width,
                    height: cc.winSize.height
                };
                if(param && typeof(param) == 'object' && param.rc){
                    rc = param.rc;
                }
                self._owner.shareCapture(sharetitle, rc, stype, param, '', () =>{
                    if(isdiff){
                        pro.adcnt+=1;
                    }else{
                        pro.srcnt+=1;
                    }
                    self.saveInfo();
                    cb && cb(true, 1, self.SHARE_FLAG, false, isdiff);
                }, (err)=>{
                    cb && cb(false, -101, self.SHARE_FLAG, false, isdiff);
                }, ite);
            }else{
                self._owner.shareNormal(sharetitle, iconUrl, stype, param, '', ()=>{
                    if(isdiff){
                        pro.adcnt+=1;
                    }else{
                        pro.srcnt+=1;
                    }
                    self.saveInfo();
                    cb && cb(true, 1, self.SHARE_FLAG, false, isdiff);
                }, (err)=>{
                    cb && cb(false, -100, self.SHARE_FLAG, false, isdiff);
                }, ite);
            }
        }

        if (isShare) {
            shareMe();
        } else {
            let adid = sdt.ad_id;
            if(sdt.adlst.length > 0){
                let idx = sdt.adlst.length == 1? 0: Math.round(Math.random() * (sdt.adlst.length - 1));
                adid = sdt.adlst[idx];
            }
            this._owner.ADWatch(adid, stype, () =>{
                if(isdiff){
                    pro.srcnt+=1;
                }else{
                    pro.adcnt+=1;
                }
                this.saveInfo();
                cb && cb(true, 2, this.AD_FLAG, false, isdiff);
            }, (err, iserr)=>{
                if(iserr && !isonlyad){
                    shareMe(true);
                }else{
                    cb && cb(false, -200, this.AD_FLAG, iserr, isdiff);
                }
            });
        }
        return true;
    },
    /**
     * 分享内容从服务端配置获取，优先观看视频，观看视频次数耗尽后分享, 一般调用jcfw中的ADShareCommon方法
     * 视频观看次数从redis配置的video_count获取
     * 分享内容根据stype,从服务端获取的分享配置中获取, 没有该类型分享配置的话,读取type为adnormal的配置
     * @param {string} stype  分享类型
     * @param {object} param  额外参数
     * @param {function} cb
     *
     * */
    AD_Share_Common(stype, param, cb){
        if(!this._rinfo){
            cb && cb(false, -1, 0);
            return false;
        }

        let sdt = this._rinfo[stype];

        if(!sdt){
            sdt = this._rinfo['adnormal'];
        }

        if(!sdt){
            cb && cb(false, -2, 0);
            return false;
        }
        let isShare = this.checkAdShareCommon();

        let pro = this._adshare[AD_SHARE_COMMON];
        let self = this;
        let shareMe = function () {
            let iconUrl = '';
            let sharetitle = '';
            let ite = 0;
            if (sdt.images.length > 0) {
                ite = strutils.randomInt(sdt.images.length-1);
                iconUrl = sdt.images[ite];
                sharetitle = sdt.strs[ite];

                if(param && typeof(param) == 'object' && typeof(param.titleparam) == 'object' &&
                    Object.prototype.toString.call(param.titleparam) === "[object Array]"){
                    sharetitle = sharetitle.format(param.titleparam);
                }
            }

            let bcapture = false;
            if(sdt.ad_cd && typeof(sdt.ad_cd) == 'object'){
                bcapture = sdt.ad_cd.iscapture;
            }
            if(bcapture){
                let rc = {
                    x: 0,
                    y: 0,
                    width: cc.winSize.width,
                    height: cc.winSize.height
                };
                if(param && typeof(param) == 'object' && param.rc){
                    rc = param.rc;
                }
                self._owner.shareCapture(sharetitle, rc, stype, param, '', () =>{
                    pro.srcnt+=1;
                    self.saveInfo();
                    cb && cb(true, 1);
                }, (err)=>{
                    cb && cb(false, -100, self.SHARE_FLAG);
                }, ite);
            }else{
                self._owner.shareNormal(sharetitle, iconUrl, stype, param, '', ()=>{
                    pro.srcnt+=1;
                    self.saveInfo();
                    cb && cb(true, 1);
                }, (err)=>{
                    cb && cb(false, -100, self.SHARE_FLAG);
                }, ite);
            }
        }
        if (isShare) {
            shareMe();
        } else {
            let adid = sdt.ad_id;
            if(sdt.adlst.length > 0){
                let idx = sdt.adlst.length == 1? 0: Math.round(Math.random() * (sdt.adlst.length - 1));
                adid = sdt.adlst[idx];
            }
            this._owner.ADWatch(adid, stype, () =>{
                pro.adcnt+=1;
                this.saveInfo();
                cb && cb(true, 2);
            }, (err, iserr)=>{
                // cb && cb(false, -200, this.AD_FLAG);
                console.log(err, iserr);
                if (iserr) {
                    shareMe();
                } else {
                    cb && cb(false, -200, this.AD_FLAG);
                }
            });
        }
        return true;
    },
    /**
     * 检查当天是否还可以播放视频激励广告
     * */
    checkAdShareCommon() {
        let videoDayCount = 0;
        if (this._owner.maincfg && this._owner.maincfg.info && this._owner.maincfg.info['video_count']) {
            videoDayCount = parseInt(this._owner.maincfg.info['video_count']);
        }
        let today = dateutils.getToday();
        let pro = this._adshare && this._adshare[AD_SHARE_COMMON];
        if(!pro || pro.day !== today){
            pro = {
                adcnt: 0,
                srcnt: 0,
                day: today
            };
            this._adshare[AD_SHARE_COMMON] = pro;
        }
        return pro.adcnt >= videoDayCount;
    },
    getRandomVideoAdId() {
        let sdt = this._rinfo['adnormal'];

        if (!sdt) {
            return '';
        }
        let adid = sdt.ad_id;
        if(sdt.adlst.length > 0){
            let idx = sdt.adlst.length == 1? 0: Math.round(Math.random() * (sdt.adlst.length - 1));
            adid = sdt.adlst[idx];
        }
        return adid;
    }
};


module.exports = JCADShareCtrl;
