
var httpclient = require('../common/httpclient');
var urlbuilder = require('../common/urlbuilder');

var jccloud = {
    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    // start () {},

    // update (dt) {},

    __getConfig(accountid, sessionid, channelid, gameid, actionname, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Config')
        .addKV('a', actionname)
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('gameid', gameid)
        .addKV('channel', channelid)
        ;
        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                if(CC_DEBUG){
                    console.log('[__getConfig]success!'+JSON.stringify(obj));
                }
                var kvobj = obj.KVList? httpclient.JSON_parse(obj.KVList): [];
                if(kvobj){
                    successcb && successcb(kvobj);
                }else{
                    failcb && failcb(0, -1, "kvlist is not obj");
                }
            }else{
                console.log('[__getConfig]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__getConfig]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __getStorage(accountid, sessionid, token, skey, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'getStorage')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('access_token', token)
        .addKV('keys', skey);
        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[__getStorage]success!'+JSON.stringify(obj));
                //var kvobj = httpclient.JSON_parse(obj.KVList);
                var kvobj = obj.KVList;
                if(kvobj){
                    successcb && successcb(kvobj);
                }else{
                    failcb && failcb(0, -1, "kvlist is not obj");
                }
            }else{
                console.log('[__getStorage]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__getStorage]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __getExpireTime(accountid, sessionid, token, skey, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'ttl')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('access_token', token)
        .addKV('keys', skey);
        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[__getExpireTime]success!'+JSON.stringify(obj));
                var ktobj = httpclient.JSON_parse(obj.KTList);
                if(ktobj){
                    successcb && successcb(ktobj);
                }else{
                    failcb && failcb(0, -1, "kvlist is not obj");
                }
            }else{
                console.log('[__getExpireTime]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__getExpireTime]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __setStorage(accountid, sessionid, token, kvlist, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'setStorage')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('access_token', token);

        let value = JSON.stringify(kvlist);

        httpclient.httpPost(this.urlbd.baseurl, value, function(restext){
            let obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[__setStorage]success!'+JSON.stringify(obj));
                successcb && successcb();
            }else{
                console.log('[__setStorage]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__setStorage]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __setExpireTime(accountid, sessionid, token, skey, origntype, timevalue, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'expire')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('access_token', token)
        .addKV('keys', skey)
        .addKV('time_origin', origntype)
        .addKV('time_val', timevalue);

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            let obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[__delStorage]success!'+JSON.stringify(obj));
                successcb && successcb();
            }else{
                console.log('[__delStorage]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__delStorage]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __clearStorage(accountid, sessionid, token, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'clearStorage')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('access_token', token);

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            let obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[__clearStorage]success!'+JSON.stringify(obj));
                successcb && successcb();
            }else{
                console.log('[__clearStorage]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__clearStorage]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __delStorage(accountid, sessionid, token, skey, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'delKeys')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('access_token', token)
        .addKV('keys', skey);

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            let obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[__delStorage]success!'+JSON.stringify(obj));
                successcb && successcb();
            }else{
                console.log('[__delStorage]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__delStorage]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __getShareConfig(accountid, sessionid, channelid, gameid, sex, province, city, successcb, failcb){
        let str = gameid + '_' + channelid;
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Config')
        .addKV('a', 'share')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('gameid', str)
        .addKV('sex', sex)
        .addKV('province', province)
        .addKV('city', city)
        ;

        let self = this;
        // console.log(self.urlbd.baseurl);
        httpclient.httpGet(self.urlbd.baseurl, function(restext){
            let obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                if(CC_DEBUG){
                    console.log('[__getShareConfig]success!'+JSON.stringify(obj));
                }
                successcb && successcb(obj.share_info);
            }else{
                console.log(self.urlbd.baseurl);
                console.log('[__getShareConfig]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log(self.urlbd.baseurl);
            console.log('[__getShareConfig]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __getBigData(accountid, sessionid, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'bigDataRead')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid);
        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                //console.log('[__getBigData]success!');
                if(!obj.data){
                    successcb && successcb(null);
                }else{
                    var kvobj = httpclient.JSON_parse(obj.data);
                    if(kvobj){
                        successcb && successcb(kvobj);
                    }else{
                        failcb && failcb(0, -1, "kvlist is not obj");
                    }
                }
            }else{
                console.log('[__getBigData]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__getBigData]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __setBigData(accountid, sessionid, data, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'CloudStorage')
        .addKV('a', 'bigDataSave')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid);

        let value = JSON.stringify(data);

        httpclient.httpPost(this.urlbd.baseurl, value, function(restext){
            let obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                //console.log('[__setBigData]success!');
                successcb && successcb();
            }else{
                console.log('[__setBigData]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__setBigData]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    init(channelid, gameid, isoffical, owner, url){
        this.gameid = gameid;
        this.channelid = channelid;
        this.token = '';
        this.urlbd = new urlbuilder(url);
        this.cfg = {
            _reborntype: -1,
            _getrewardtype: -1,
            _exchange_rewardtype: -1,
            _navigateflag: -1,
            _serverversion: -1,
            _gglFlag: -1
        };
        this.cfginited = false;
        this.sex = 0;
        this.province = '';
        this.city = '';
        console.log("[jccloud]init:"+gameid + "|" + channelid + "|" + isoffical);
    },

    setAccountID(accountid, sessionid, resinfo){
        this.accountid = accountid;
        this.sessionid = sessionid;
        if(resinfo){
            this.sex = resinfo.sex;
            this.province = resinfo.province;
            this.city = resinfo.city;
        }
    },

    setNickName(nickname){
        this.nickname = nickname;
    },

    setFromAppID(appid){
        this.fromid = appid;
    },

    setLocalUUID(uuid){
        this.localid = uuid;
    },

    setSystemInfo(info){

    },

    setUserInfo(info){
        if(info){
            this.sex = info.sex;
            this.province = info.province;
            this.city = info.city;
        }
    },

    getConfig(successcb, failcb){
        if(this._configgetting){
            return 1;
        }
        this._configgetting = true;
        this.__getConfig(this.accountid, this.sessionid, this.channelid, this.gameid, 'read', (kvlist) => {
            this._configgetting = false;
            successcb && successcb(kvlist);
        }, (neterr, logicerr, errmsg) => {
            this._configgetting = false;
            failcb && failcb(neterr, logicerr, errmsg);
        });
        return 0;
    },

    initConfig(successcb, failcb){
        if(this.cfginited){
            successcb && successcb(this.cfg);
            return 0;
        }
        this.cfginited = false;
        return this.getConfig((res) => {
            if(CC_DEBUG){
                console.log(JSON.stringify(res));
            }
            if(res instanceof Array){
                res.forEach(element => {
                    if(element.key == 'reborn'){
                        this.cfg._reborntype = element.value;
                    }else if(element.key == 'share_reward'){
                        this.cfg._getrewardtype = element.value;
                    }else if(element.key == 'exchange_reward'){
                        this.cfg._exchange_rewardtype = element.value;
                    }else if(element.key == 'navigate'){
                        this.cfg._navigateflag = element.value;
                    }else if(element.key == 'version'){
                        this.cfg._serverversion = element.value;
                    }else if(element.key == 'ggl'){
                        this.cfg._gglFlag = element.value;
                    }else if(element.key == 'festival'){
                        this.cfg._festivalFlag = element.value;
                    }else{
                        this.cfg[element.key] = element.value;
                    }
                });
				this.cfginited = true;
                successcb && successcb(this.cfg);
            }else{
                failcb && failcb(0, -1, '');
            }
        }, (neterr, logicerr, errmsg) =>{
            failcb && failcb(neterr, logicerr, errmsg);
        });
    },

    _getPrivateConfig(successcb, failcb){
        if(this._pvconfiggetting){
            return 1;
        }
        this._pvconfiggetting = true;
        this.__getConfig(this.accountid, this.sessionid, this.channelid, this.gameid, 'readPrivate', (kvlist) => {
            this._pvconfiggetting = false;
            successcb && successcb(kvlist);
        }, (neterr, logicerr, errmsg) => {
            this._pvconfiggetting = false;
            failcb && failcb(neterr, logicerr, errmsg);
        });
        return 0;
    },

    initPrivateConfig(successcb, failcb){
        if(this.pvcfginited){
            successcb && successcb(this.pvcfg);
            return 0;
        }
        this.pvcfginited = false;
        return this._getPrivateConfig((res) => {
            if(CC_DEBUG){
                console.log(JSON.stringify(res));
            }
            if(res instanceof Array){
                if(!this.pvcfg){
                    this.pvcfg = {};
                }
                res.forEach(element => {
                    this.pvcfg[element.key] = element.value;
                });
				this.pvcfginited = true;
                successcb && successcb(this.pvcfg);
            }else{
                failcb && failcb(0, -1, '');
            }
        }, (neterr, logicerr, errmsg) =>{
            failcb && failcb(neterr, logicerr, errmsg);
        });
    },

    // 获取服务器配置
    getServerConfig(successcb, failcb, bForce){
        if(bForce){
            this.cfginited = false;
        }
        return this.initConfig(successcb, failcb);
    },

    getPrivateConfig(successcb, failcb, bForce){
        if(bForce){
            this.pvcfginited = false;
        }
        return this.initPrivateConfig(successcb, failcb);
    },

    getShareConfig(successcb, failcb){
        if(this._shconfiggetting){
            return 1;
        }
        this._shconfiggetting = true;
        this.__getShareConfig(this.accountid, this.sessionid, this.channelid, this.gameid,
            this.sex, this.province, this.city, (kvlist) => {
                this._shconfiggetting = false;
                successcb && successcb(kvlist);
            }, (neterr, logicerr, errmsg) => {
                this._shconfiggetting = false;
                failcb && failcb(neterr, logicerr, errmsg);
            });
    },

    initShareConfig(successcb, failcb, bForce){
        if(bForce){
            this.shcfginited = false;
        }
        if(this.shcfginited){
            successcb && successcb(this.shcfglst);
            return 0;
        }
        this.pvcfginited = false;
        return this.getShareConfig((res) => {
            if(res instanceof Array){
                if(this.shcfglst){
                    this.shcfglst.length = 0;
                }
                this.shcfglst = res;
                // res.forEach(element => {
                //     this.shcfg[element.key] = element.value;
                // });
				this.shcfginited = true;
                successcb && successcb(this.shcfglst);
            }else{
                failcb && failcb(0, -1, '');
            }
        }, (neterr, logicerr, errmsg) =>{
            failcb && failcb(neterr, logicerr, errmsg);
        });
    },

    setStorage: function(skey, svalue, successcb, failcb, timeorign_type, time_value){
        let obj = {
            key: skey,
            value: svalue
        };
        if(timeorign_type && time_value){
            obj.time_origin = timeorign_type;
            obj.time_val = time_value;
        }
        let lst = [obj];
        this.__setStorage(this.accountid, this.sessionid, this.token, lst, successcb, failcb);
    },

    setStorages: function(kvlist, successcb, failcb){
        this.__setStorage(this.accountid, this.sessionid, this.token, kvlist, successcb, failcb);
    },

    getStorage: function(key, successcb, failcb){
       this.__getStorage(this.accountid, this.sessionid, this.token, key, (kvlist) => {
            if(kvlist.length > 0){
                let obj = kvlist[0];
                successcb && successcb(obj.value, obj.ttl_seconds, obj.key);
            }else{
                successcb && successcb(null, -1, key);
            }
       }, failcb);
    },

    getStorages: function(keylist, successcb, failcb){
        let skey = keylist.join();
        this.__getStorage(this.accountid, this.sessionid, this.token, skey, successcb, failcb);
    },

    delStorage: function(key, successcb, failcb){
        this.__delStorage(this.accountid, this.sessionid, this.token, key, successcb, failcb);
    },

    delStorages: function(keylist, successcb, failcb){
        let skey = keylist.join();
        this.__delStorage(this.accountid, this.sessionid, this.token, skey, successcb, failcb);
    },

    clearStorage: function(successcb, failcb){
        this.__clearStorage(this.accountid, this.sessionid, this.token, successcb, failcb);
    },

    setExpireTime: function(key, timeorign_type, time_value, successcb, failcb){
        this.__setExpireTime(this.accountid, this.sessionid, this.token, key, timeorign_type, time_value, successcb, failcb);
    },

    setExpireTimes: function(keylist, timeorign_type, time_value, successcb, failcb){
        let skey = keylist.join();
        this.__setExpireTime(this.accountid, this.sessionid, this.token, skey, timeorign_type, time_value, successcb, failcb);
    },

    getExpireTime: function(key, successcb, failcb){
        this.__getStorage(this.accountid, this.sessionid, this.token, key, (ktlist) => {
            if(ktlist.length > 0){
                let obj = ktlist[0];
                successcb && successcb(obj.ttl_seconds, obj.key);
            }else{
                successcb && successcb(-1, key);
            }
       }, failcb);
    },

    getExpireTimes: function(key, successcb, failcb){
        this.__getStorage(this.accountid, this.sessionid, this.token, key, successcb, failcb);
    },

    getBigData: function(successcb, failcb) {
        this.__getBigData(this.accountid, this.sessionid, successcb, failcb);
    },

    setBigData: function(data, successcb, failcb) {
        this.__setBigData(this.accountid, this.sessionid, data, successcb, failcb);
    }
};
module.exports = jccloud;
