var httpclient = require('../common/httpclient');

let jcgoods = {
  init(channelid, gameid, isoffical, owner, url){
    this.owner = owner;
    this.gameid = gameid;
    this.channelid = channelid;
    this.isoffical = isoffical;
    if (CC_DEBUG) {
      this.channelid = '6001';
    }
    this.url = url.replace('webapp/index.php', 'api/gift');
    console.log("[jcgoodsctrl]init:"+gameid + "|" + channelid + "|" + isoffical);
    if (CC_DEBUG) {
      // this.channelid = '6001';
    }
  },

  setAccountID(accountid, sessionid){
    this.accountid = accountid;
    this.sessionid = sessionid;
  },

  setNickName(nickname){
    this.nickname = nickname;
  },
  // 获取可兑换物品列表
  giftList(successcb, failcb) {
    if(!this.url){
      failcb && failcb(0, -1234, 'not inited!');
      return;
    }
    const url = `${this.url}/list?gameId=${this.gameid}&channelId=${this.channelid}`;
    httpclient.httpGet(url, (restext) => {
      let obj
      try {
        obj = httpclient.JSON_parse(restext);
      } catch (err) {}
      if(obj && obj.errcode === 0){
        successcb && successcb(obj.result);
      }else{
        console.log('[jcgoods] giftList failed!'+ obj ? obj.errcode : '' +":"+ obj ? obj.errmsg : '');
        failcb && failcb(0, obj ? obj.errcode : -1235, obj ? obj.errmsg : '');
      }

    }, (errcode, errmsg) => {
      console.log('[jcgoods] giftList failed!'+errcode+":"+errmsg);
      failcb && failcb(errcode, 0, errmsg);
    });

  },

  /**
   * 兑换一个物品
   * @param giftId: 从可兑换物品列表中获取的giftId
   * @param listId: 从可兑换物品列表中获取的list_id
   * @param successcb 成功回调 参数
   *              recordId: 用于查询单条兑换记录
   *              code:   兑换码
   * */
  reqExchange(giftId, listId, successcb, failcb) {
    if(!this.url){
      failcb && failcb(0, -1234, 'not inited!');
      return;
    }
    let data = {accountId: this.owner.accountID,
      sessionId: this.owner.sessionID,
      gameId: this.gameid,
      channelId: this.channelid,
      giftId: giftId,
      listId: listId,
    };
    const url = `${this.url}/exchange`;
    httpclient.httpPost(url, JSON.stringify(data), (restext) => {
      let obj
      try {
        obj = httpclient.JSON_parse(restext);
      } catch (err) {}
      if(obj && obj.errcode === 0){
        console.log('[jcgoods] reqExchange success', obj);
        successcb && successcb(obj);
      }else{
        console.log('[jcgoods] reqExchange failed!',  obj ? obj.errcode : '', obj ? obj.errmsg : '');
        failcb && failcb(0, obj ? obj.errcode : -1235, obj ? obj.errmsg : '');
      }

    }, (errcode, errmsg) => {
      console.log('[jcgoods] reqExchange failed!'+errcode+":"+errmsg);
      failcb && failcb(errcode, 0, errmsg);
    }, 'application/json');

  },

  phoneRecharge(recordId, phone, successcb, failcb) {
    if(!this.url){
      failcb && failcb(0, -1234, 'not inited!');
      return;
    }
    let data = {
      accountId: this.owner.accountID,
      sessionId: this.owner.sessionID,
      recordId: recordId,
      phone: phone,
    };
    const url = `${this.url}/tel`;
    httpclient.httpPost(url, JSON.stringify(data), (restext) => {
      let obj
      try {
        obj = httpclient.JSON_parse(restext);
      } catch (err) {}
      if(obj && obj.errcode === 0){
        console.log('[jcgoods] phoneRecharge success', obj);
        successcb && successcb(obj);
      }else{
        console.log('[jcgoods] phoneRecharge failed!',  obj ? obj.errcode : '', obj ? obj.errmsg : '');
        failcb && failcb(0, obj ? obj.errcode : -1235, obj ? obj.errmsg : '');
      }

    }, (errcode, errmsg) => {
      console.log('[jcgoods] phoneRecharge failed!'+errcode+":"+errmsg);
      failcb && failcb(errcode, 0, errmsg);
    }, 'application/json');
  },

  itemExchange(recordId, phone, successcb, failcb) {
    if(!this.url){
      failcb && failcb(0, -1234, 'not inited!');
      return;
    }
    let data = {
      accountId: this.owner.accountID,
      sessionId: this.owner.sessionID,
      recordId: recordId,
      phone: phone,
    };
    const url = `${this.url}/goods`;
    httpclient.httpPost(url, JSON.stringify(data), (restext) => {
      let obj
      try {
        obj = httpclient.JSON_parse(restext);
      } catch (err) {}
      if(obj && obj.errcode === 0){
        console.log('[jcgoods] phoneRecharge success', obj);
        successcb && successcb(obj);
      }else{
        console.log('[jcgoods] phoneRecharge failed!',  obj ? obj.errcode : '', obj ? obj.errmsg : '');
        failcb && failcb(0, obj ? obj.errcode : -1235, obj ? obj.errmsg : '');
      }

    }, (errcode, errmsg) => {
      console.log('[jcgoods] phoneRecharge failed!'+errcode+":"+errmsg);
      failcb && failcb(errcode, 0, errmsg);
    }, 'application/json');
  }

};

module.exports = jcgoods;
