
var httpclient = require('../common/httpclient');
var urlbuilder = require('../common/urlbuilder');

let jclogin = {
    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    //start () {},

    // update (dt) {},

    __login(channelid, gameid, tokencode, isoffical, successcb, failcb, openid, isGuest, anonymousToaken){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Login')
        .addKV('a', 'auth')
        .addKV('gameid', gameid)
        .addKV('channel', channelid)
        .addKV('token', tokencode);
        if(openid && openid != ''){
            this.urlbd.addKV('openid', openid);
        }
        if (anonymousToaken) {
            this.urlbd.addKV('anonymous_token', anonymousToaken);
        }

        if(this.env){
            this.urlbd.addKV('env', this.env);
        }
        this.urlbd.addKV('is_guest', isGuest || 0);

        if(this.polyid){
            let sid = this.polyid + '';
            this.urlbd.addKV('poly_sdk_channel', sid);
        }

        console.log("[__login]start");
        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__login]success!'+JSON.stringify(obj));
                successcb && successcb(obj);
            }else{
                console.log('[__login]failed!'+restext);
                failcb && failcb(0, obj?obj.errcode:-1, obj?obj.errmsg:restext);
            }
        }, function(errcode, errmsg){
            console.log('[__login]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __activeWX(gameid, accountid, sessionid, raw, sign, encyptdata, iv, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Login')
        .addKV('a', 'activateWeiXinUser')
        .addKV('gameid', gameid)
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('rawdata', raw)
        .addKV('signature', sign)
        .addKV('encrypted_data', encyptdata)
        .addKV('iv', iv)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            if(restext == ''){
                failcb && failcb(0, -1, "restext is nullstring!");
                return;
            }
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__activeWX]success!'+JSON.stringify(obj));
                successcb && successcb(obj);
            }else{
                console.log('[__activeWX]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__activeWX]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __updateInfo(accountid, sessionid, usrinfo, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Login')
        .addKV('a', 'updateUserInfo')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('nickname', usrinfo.nickname)
        .addKV('city', usrinfo.city)
        .addKV('province', usrinfo.province)
        .addKV('avatar_url', usrinfo.avatar_url)
        .addKV('country', usrinfo.country)
        .addKV('sex', usrinfo.sex)
        .addKV('birthday', usrinfo.birthday)
        .addKV('phone', usrinfo.phone)
        .addKV('location', usrinfo.location)
        ;
        // if(!this.isoffical){
        //     console.log(this.urlbd.baseurl);
        // }
        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__updateInfo]success!'+JSON.stringify(obj));
                obj.userInfo = usrinfo;
                successcb && successcb(obj);
            }else{
                console.log('[__updateInfo]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__updateInfo]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __generalSignature(accountid, sessionid, signdata, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Login')
        .addKV('a', 'signature')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('params', signdata)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__generalSignature]success!'+JSON.stringify(obj));
                successcb && successcb(obj);
            }else{
                console.log('[__generalSignature]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__generalSignature]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __generalToken(accountid, sessionid, sceneid, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Login')
        .addKV('a', 'getAccessToken')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('scene', sceneid)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__generalToken]success!'+JSON.stringify(obj));
                successcb && successcb(obj);
            }else{
                console.log('[__generalToken]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__generalToken]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __getAnnouncement(channelid, gameid, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Annc')
        .addKV('a', 'getAnnouncement')
        .addKV('gameid', gameid)
        .addKV('channel', channelid)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__getAnnouncement]success!'+JSON.stringify(obj));
                successcb && successcb(obj);
            }else{
                console.log('[__getAnnouncement]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__getAnnouncement]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __getServerList(channelid, gameid, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SrvList')
        .addKV('a', 'getSrvList')
        .addKV('gameid', gameid)
        .addKV('channel', channelid);

        if(this.env){
            this.urlbd.addKV('env', this.env);
        }

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__getServerList]success!'+JSON.stringify(obj));
                successcb && successcb(obj.server_list);
            }else{
                console.log('[__getServerList]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__getServerList]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __loginYoume(accountid, sessionid, roleid, nickname, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'YouMe')
        .addKV('a', 'login')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('nickname', nickname)
        .addKV('role_id', roleid);

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__loginYoume]success!'+JSON.stringify(obj));
                successcb && successcb(obj.token);
            }else{
                console.log('[__loginYoume]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__loginYoume]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __registerJCAccount(account, pwd, phone, smscode, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SelfSdk')
        .addKV('a', 'registerAccount')
        .addKV('account', account)
        .addKV('passwd', pwd)
        .addKV('phone', phone)
        .addKV('sms_auth_code', smscode)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__registerAccount]success!'+JSON.stringify(obj));
                successcb && successcb(obj.token, obj.age);
            }else{
                console.log('[__registerAccount]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__registerAccount]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __loginJCAnonymous(successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SelfSdk')
        .addKV('a', 'guestLogin')
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__loginJCAnonymous]success!'+JSON.stringify(obj));
                successcb && successcb(obj.token);
            }else{
                console.log('[__loginJCAnonymous]failed!');
                failcb && failcb(0, obj? obj.errcode: -1, obj? obj.errmsg: '');
            }
        }, function(errcode, errmsg){
            console.log('[__loginJCAnonymous]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __loginJCByID(account, pwd, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SelfSdk')
        .addKV('a', 'login')
        .addKV('account', account)
        .addKV('passwd', pwd)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__loginJC]success!'+JSON.stringify(obj));
                successcb && successcb(obj.token, obj.age);
            }else{
                console.log('[__loginJC]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__loginJC]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __loginJCBySMS(phone, smscode, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SelfSdk')
        .addKV('a', 'smsLogin')
        .addKV('phone', phone)
        .addKV('sms_auth_code', smscode)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__loginSMS]success!'+JSON.stringify(obj));
                successcb && successcb(obj.token);
            }else{
                console.log('[__loginSMS]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__loginSMS]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __sendSMSCode(phone, code_type, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SelfSdk')
        .addKV('a', 'sendSmsCode')
        .addKV('phone', phone)
        .addKV('code_type', code_type)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__sendSMSCode]success!'+JSON.stringify(obj));
                successcb && successcb();
            }else{
                console.log('[__sendSMSCode]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__sendSMSCode]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __getIPInfo(successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Login')
        .addKV('a', 'getIpInfo')
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__getIPInfo]success!'+JSON.stringify(obj));
                successcb && successcb(obj.token);
            }else{
                console.log('[__getIPInfo]failed!'+obj? obj.errcode: 0+":"+obj?obj.errmsg:'');
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__getIPInfo]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    // 更新在线时长
    __updateGameDuration(accountid, sessionid, successcb, failcb, sec){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SelfSdk')
        .addKV('a', 'updateGameDuration')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('inc_time', sec)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                // console.log('[__updateGameDuration]success!'+JSON.stringify(obj));
                successcb && successcb(parseInt(obj.game_duration));
            }else{
                console.log('[__updateGameDuration]failed!'+obj? obj.errcode: 0+":"+obj?obj.errmsg:'');
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__updateGameDuration]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    __bindIdCard(accountid, sessionid, name, idcard, isfake, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'SelfSdk')
        .addKV('a', 'bindIdCard')
        .addKV('account_id', accountid)
        .addKV('session_id', sessionid)
        .addKV('id_card', idcard)
        .addKV('real_name', name)
        .addKV('nocheck', isfake? 1: 0)
        ;

        httpclient.httpGet(this.urlbd.baseurl, function(restext){
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[__bindIdCard]success!'+JSON.stringify(obj));
                successcb && successcb(obj.age);
            }else{
                console.log('[__bindIdCard]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, function(errcode, errmsg){
            console.log('[__bindIdCard]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    _checkUserInfo(){
        if(this._localinfoloaded && this._svinfoloaded){
            if(this.userinfo.rawData){
                if(this.channelid == 6001 && !this.actived){
                    this.activewx(this.userinfo, this._activesuccess, this._activefail);
                }else{
                    if(this._combineInfo(this.svuserinfo, this.userinfo)){
                        this.updateinfo(this.svuserinfo, this._activesuccess, this._activefail);
                    }else{
                        this._activesuccess && this._activesuccess(this.userinfo);
                    }
                    // this._activefail && this._activefail(0, -1, 'is not weixin platform!');
                }
            }else{
                if(this._combineInfo(this.svuserinfo, this.userinfo)){
                    this.updateinfo(this.svuserinfo, this._activesuccess, this._activefail);
                }else{
                    this._activesuccess && this._activesuccess(this.userinfo);
                }
            }
        }
    },

    _checkNickName(){
        if(this.userinfo.nickname){
            this.owner && this.owner.setNickName(this.userinfo.nickname);
        }
    },

    _loadLocalInfo(info){
        if(!this.userinfo){
            this.userinfo = {};
        }
        this.owner.plat.setUserInfo(this.userinfo, info);
        console.log('[_loadLocalInfo]finish');
        this._localinfoloaded = true;
    },

    _loadTokenInfo(tokeninfo){
        if(!this.userinfo){
            this.userinfo = {};
        }
        this.owner.plat.setTokenInfo(this.userinfo, tokeninfo);
        this._localtokenloaded = true;
    },

    _loadServerInfo(info){
        if(!this.svuserinfo){
            this.svuserinfo = {};
        }
        this.svuserinfo.nickname = info.nickname;
        this.svuserinfo.country = info.country;
        this.svuserinfo.province = info.province;
        this.svuserinfo.city = info.city;
        this.svuserinfo.avatar_url = info.avatar_url;
        this.svuserinfo.sex = info.sex;
        this.svuserinfo.birthday = info.birthday;
        this.svuserinfo.phone = info.phone;
        this.svuserinfo.location = info.location;
        console.log('[_loadServerInfo]finish');
        this._svinfoloaded = true;
    },

    _combineInfo(svinfo, lcinfo){
        let bupdated = false;
        if(lcinfo.nickname && svinfo.nickname != lcinfo.nickname){
            console.log('[nickname]'+svinfo.nickname+"|"+lcinfo.nickname);
            svinfo.nickname = lcinfo.nickname;
            bupdated = true;
        }
        if(lcinfo.city && (svinfo.city != lcinfo.city)){
            console.log('[city]'+svinfo.city+"|"+lcinfo.city);
            svinfo.city = lcinfo.city;
            bupdated = true;
        }
        if(lcinfo.province && (svinfo.province != lcinfo.province)){
            console.log('[province]'+svinfo.province+"|"+lcinfo.province);
            svinfo.province = lcinfo.province;
            bupdated = true;
        }
        if(lcinfo.country && (svinfo.country != lcinfo.country)){
            console.log('[country]'+svinfo.country+"|"+lcinfo.country);
            svinfo.country = lcinfo.country;
            bupdated = true;
        }
        if(lcinfo.avatar_url && (svinfo.avatar_url != lcinfo.avatar_url)){
            console.log('[avatar_url]'+svinfo.avatar_url+"|"+lcinfo.avatar_url);
            svinfo.avatar_url = lcinfo.avatar_url;
            bupdated = true;
        }
        if(lcinfo.sex && (svinfo.sex != lcinfo.sex)){
            console.log('[sex]'+svinfo.sex+"|"+lcinfo.sex);
            svinfo.sex = lcinfo.sex;
            bupdated = true;
        }
        if(lcinfo.birthday && (svinfo.birthday != lcinfo.birthday)){
            console.log('[birthday]'+svinfo.birthday+"|"+lcinfo.birthday);
            svinfo.birthday = lcinfo.birthday;
            bupdated = true;
        }
        if(lcinfo.phone && (svinfo.phone != lcinfo.phone)){
            console.log('[phone]'+svinfo.phone+"|"+lcinfo.phone);
            svinfo.phone = lcinfo.phone;
            bupdated = true;
        }
        if(lcinfo.location && (svinfo.location != lcinfo.location)){
            console.log('[location]'+svinfo.location+"|"+lcinfo.location);
            svinfo.location = lcinfo.location;
            bupdated = true;
        }

        return bupdated;
    },

    _checkOnlineTime(){
        if(this._tid){
            this._stopOnlineTime();
        }else{
            this.updateOnlineTime((duration)=>{
                this._timecb && this._timecb(duration);
            });
        }
        this._tid = setInterval(() => {
            this.updateOnlineTime((duration)=>{
                this._timecb && this._timecb(duration);
            });
        }, 10000);
    },

    _stopOnlineTime(){
        if(this._tid){
            clearInterval(this._tid);
            this._tid = 0;
        }
    },

    init(channelid, gameid, isoffical, owner, env, url, polychannelid){
        this.owner = owner;
        this.channelid = channelid;
        this.gameid = gameid;
        this.sessionid = this.sessionid? this.sessionid:'';
        this.accountid = this.accountid? this.accountid: '';
        this.openid = this.openid? this.openid: '';
        this.env = env;
        this.isoffical = isoffical;
        this.logined = this.logined? this.logined: false;
        this.urlbd = new urlbuilder(url);
        this.polyid = polychannelid;
        console.log("[jclogin]init:"+gameid + "|" + channelid + "|" + isoffical);
    },

    login(token, successcb, failcb, openid, isGuest, anonymousToaken){
        var self = this;
        this.__login(this.channelid, this.gameid, token, this.isoffical, function(obj){
            let nowtime = new Date().getTime();
            self.sessionid = obj.session_id;
            self.accountid = obj.account_id;
            self.openid = obj.openid;
            self.actived = obj.activated == true;
            self.logined = true;
            self.login_costtime = nowtime - self._loginstarttime;
            self._loadServerInfo(obj);
            self._checkUserInfo();
            successcb && successcb(obj);
        }, failcb, openid, isGuest, anonymousToaken);
    },

    // 登陆平台
    loginPT(successcb, failcb, exparam, timecb){
        this._loginstarttime = new Date().getTime();
        this._timecb = timecb;
        this.owner.plat.PTLogin(exparam, successcb, failcb);
    },

    // 更新用户信息
    updatePTInfo(userinfo, tokeninfo, successcb, failcb){
        this.updateuserinfo(userinfo, tokeninfo, successcb, failcb);
    },

    // 登陆游密
    loginYoume(uid, uname, successcb, failcb){
        this.__loginYoume(this.accountid, this.sessionid, uid, uname, successcb, failcb);
    },

    // 登陆金蚕（已有账户登录或新建账户登录）
    loginJC(info, successcb, failcb){
        if(!info){
            failcb && failcb(0, -1000, 'info is null!');
            return;
        }
        if(!info.userinfo){
            failcb && failcb(0, -2000, 'userinfo is null!');
            return;
        }

        if(info.userinfo.isanonymous){
            this.__loginJCAnonymous((code)=>{
                this.login(code, (obj)=>{
                    obj.token = code;
                    this._checkOnlineTime();
                    successcb && successcb(obj);
                }, failcb);
            }, failcb);
        }else if(info.userinfo.isnew){
            this.registerJC(info, (code, age)=>{
                this.login(code, (obj)=>{
                    obj.token = code;
                    obj.age = age;
                    this._checkOnlineTime();
                    successcb && successcb(obj);
                }, failcb);
            }, failcb);
        }else if(info.userinfo.phone && info.userinfo.sms){
            this.__loginJCBySMS(info.userinfo.phone, info.userinfo.sms, (code)=>{
                this.login(code, (obj)=>{
                    obj.token = code;
                    this._checkOnlineTime();
                    successcb && successcb(obj);
                }, failcb);
            }, failcb);
        }else{
            this.__loginJCByID(info.userinfo.id, info.userinfo.pwd, (code, age)=>{
                this.login(code, (obj)=>{
                    obj.token = code;
                    obj.age = age;
                    this._checkOnlineTime();
                    successcb && successcb(obj);
                }, failcb);
            }, failcb);
        }

    },

    // 匿名登陆
    loginAnonymous(successcb, failcb){
        this.__loginJCAnonymous((code)=>{
            this.login(code, (obj)=>{
                obj.token = code;
                obj.isGuest = true;
                successcb && successcb(obj);
            }, failcb, '', 1);
        }, failcb);
    },

    // 注册金蚕
    registerJC(info, successcb, failcb){
        if(!info || !info.userinfo){
            failcb && failcb(0, -1000, 'userinfo is null!');
            return;
        }
        this.__registerJCAccount(info.userinfo.id, info.userinfo.pwd, info.userinfo.phone, info.userinfo.sms,
            successcb, failcb);
    },

    sendSMSForLogin(phone, successcb, failcb){
        this.__sendSMSCode(phone, 1, successcb, failcb);
    },

    sendSMSForRegister(phone, successcb, failcb){
        this.__sendSMSCode(phone, 2, successcb, failcb);
    },

    // 获取用户信息后调用此方法激活账号（info为空说明授权失败）
    updateuserinfo(userinfo, tokeninfo, successcb, failcb){
        this._loadLocalInfo(userinfo);
        this._loadTokenInfo(tokeninfo);
        this._activesuccess = successcb;
        this._activefail = failcb;
        this._checkUserInfo();
        this._checkNickName();
    },

    activewx(res, successcb, failcb){
        var self = this;
        this.__activeWX(this.gameid, this.accountid, this.sessionid, res.rawData, res.signature, res.encryptedData, res.iv, function(obj){
            self.actived = true;
            successcb && successcb(obj);
        }, failcb);
    },

    updateinfo(usrinfo, successcb, failcb){
        this.__updateInfo(this.accountid, this.sessionid, usrinfo, successcb, failcb);
    },

    getToken(sceneid, successcb, failcb){
        this.__generalToken(this.accountid, this.sessionid, sceneid, successcb, failcb);
    },

    getSignature(signdata, successcb, failcb){
        this.__generalSignature(this.accountid, this.sessionid, signdata, successcb, failcb);
    },

    getAnnouncement(successcb, failcb){
        this.__getAnnouncement(this.channelid, this.gameid, successcb, failcb);
    },

    getServerList(successcb, failcb){
        this.__getServerList(this.channelid, this.gameid, successcb, failcb);
    },

    /**
     *
     * @param {string} name : 真实姓名
     * @param {string} idcard : 真实身份证号
     * @param {boolean} isfake : 是否是假的（不校验）
     * @param {object} successcb : 成功回调，参数为玩家年龄
     * @param {object} failcb : 失败回调
     */
    bindIdCard(name, idcard, isfake, successcb, failcb){
        this.__bindIdCard(this.accountid, this.sessionid, name, idcard, isfake, successcb, failcb);
    },

    updateOnlineTime(successcb, failcb){
        let sec = CC_DEBUG? 1000: 10;
        this.__updateGameDuration(this.accountid, this.sessionid, successcb, failcb, sec);
    },

    isActived(){
        return this.actived;
    },

    AccountID(openid){
        if(this.accountid && this.accountid != ''){
            return this.accountid;
        }
        return this.channelid+"_"+this.gameid+"_"+openid;
    },

    setAccountID(accountid, sessionid){
        this.accountid = accountid;
        this.sessionid = sessionid;
    },

    setNickName(nickname){
        this.nickname = nickname;
    },

    setFromAppID(appid){
        this.fromid = appid;
    },

    setLocalUUID(uuid){
        this.localid = uuid;
    },

    clear(){
        this._localinfoloaded =false;
        this._svinfoloaded   =false;
        this._stopOnlineTime();
    },

    setSystemInfo(info){

    },

    appendUserInfo(dstinfo, srcinfo){
        if(!dstinfo){
            return false;
        }
        dstinfo.nickname = dstinfo.nickname || '';
        dstinfo.country = dstinfo.country || '';
        dstinfo.province = dstinfo.province || '';
        dstinfo.city = dstinfo.city || '';
        dstinfo.avatar_url = dstinfo.avatar_url || '';
        dstinfo.sex = dstinfo.sex || 0;
        dstinfo.birthday = dstinfo.birthday || '';
        dstinfo.phone = dstinfo.phone || '';
        dstinfo.location = dstinfo.location || '';
        if(srcinfo){
            this.owner.plat.setUserInfo(dstinfo, srcinfo);
            // for (var attr in srcinfo) {
            //     dstinfo[attr] = srcinfo[attr];
            // }
        }
    },

};

module.exports = jclogin;
