var httpclient = require('../common/httpclient');
var urlbuilder = require('../common/urlbuilder');

let jcmail = {
    init(channelid, gameid, isoffical, owner, url) {
        this.owner = owner;
        this.gameid = gameid;
        this.channelid = channelid;
        this.isoffical = isoffical;
        this.urlbd = new urlbuilder(url);
        console.log("[jcmailctrl]init:" + gameid + "|" + channelid + "|" + isoffical);
    },

    setAccountID(accountid, sessionid) {
        this.accountid = accountid;
        this.sessionid = sessionid;
    },

    setNickName(nickname) {
        this.nickname = nickname;
    },

    setFromAppID(appid) {
        this.fromid = appid;
    },

    setLocalUUID(uuid) {
        this.localid = uuid;
    },

    setSystemInfo(info) {

    },

    setServerTime(servertime, localtime) {
        this.loginSrvTime = servertime;
        this.loginLocalTime = localtime;
    },

    sendNewMail(data, successcb, failcb) {
        if (!this.urlbd) {
            failcb && failcb(0, -1234, 'not inited!');
            return;
        }
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Mail')
            .addKV('a', 'sendMail')
            .addKV('game_id', 3100)
            .addKV('to', this.accountid)
            .addKV('from', 'sys')
            .addKV('mail_type', 1)
            .addKV('mail_subtype', 1)
            .addKV('content', '测试邮件，雪峰写文本')
            .addKV('subject', '邮件主题，雪峰写文本')
            .addKV('send_time', data.send_time)
            .addKV('expire_time', data.expire_time)
            .addKV('attachments', data.attachments);
        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if (obj && obj.errcode == 0) {
                console.log('[sendNewMail]success!' + JSON.stringify(obj));
                successcb && successcb();
                // var maillist = obj.maillist;
                // if (maillist) {
                //     successcb && successcb(maillist);
                // } else {
                //     failcb && failcb(0, -1, "maillist is not obj");
                // }
            } else {
                console.log('[sendNewMail]failed!' + obj.errcode + ":" + obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }

        }, (errcode, errmsg) => {
            console.log('[sendNewMail]failed!' + errcode + ":" + errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    reqMailList(successcb, failcb) {
        if (!this.urlbd) {
            failcb && failcb(0, -1234, 'not inited!');
            return;
        }
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Mail')
            .addKV('a', 'getMailList')
            .addKV('session_id', this.sessionid)
            .addKV('account_id', this.accountid);
        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if (obj && obj.errcode == 0) {
                console.log('[reqMailList]success!' + JSON.stringify(obj));
                var maillist = obj.maillist;
                if (maillist) {
                    successcb && successcb(maillist);
                } else {
                    failcb && failcb(0, -1, "maillist is not obj");
                }
            } else {
                console.log('[reqMailList]failed!' + obj.errcode + ":" + obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }

        }, (errcode, errmsg) => {
            console.log('[reqMailList]failed!' + errcode + ":" + errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    reqGetAttachment(mailids, successcb, failcb) {
        if (!this.urlbd) {
            failcb && failcb(0, -1234, 'not inited!');
            return;
        }
        let lst = mailids instanceof Array ? mailids : [mailids];
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Mail')
            .addKV('a', 'getAttachment')
            .addKV('session_id', this.sessionid)
            .addKV('account_id', this.accountid)
            .addKV('mail_ids', lst.join());
        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if (obj && obj.errcode == 0) {
                console.log('[reqGetAttachment]success!' + JSON.stringify(obj));
                successcb && successcb(lst);
            } else {
                console.log('[reqGetAttachment]failed!' + obj.errcode + ":" + obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }

        }, (errcode, errmsg) => {
            console.log('[reqGetAttachment]failed!' + errcode + ":" + errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    reqMarkMail(mailids, successcb, failcb) {
        if (!this.urlbd) {
            failcb && failcb(0, -1234, 'not inited!');
            return;
        }
        let lst = mailids instanceof Array ? mailids : [mailids];
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Mail')
            .addKV('a', 'markMail')
            .addKV('session_id', this.sessionid)
            .addKV('account_id', this.accountid)
            .addKV('mail_ids', lst.join())
            .addKV('flag', 'read');
        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if (obj && obj.errcode == 0) {
                console.log('[reqMarkMail]success!' + JSON.stringify(obj));
                successcb && successcb(lst);
            } else {
                console.log('[reqMarkMail]failed!' + obj.errcode + ":" + obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }

        }, (errcode, errmsg) => {
            console.log('[reqMarkMail]failed!' + errcode + ":" + errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    reqGetUnreadMailCount(successcb, failcb) {
        if (!this.urlbd) {
            failcb && failcb(0, -1234, 'not inited!');
            return;
        }
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Mail')
            .addKV('a', 'getUnreadMailCnt')
            .addKV('session_id', this.sessionid)
            .addKV('account_id', this.accountid);
        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if (obj && obj.errcode == 0) {
                console.log('[reqGetUnreadMailCount]success!' + JSON.stringify(obj));
                successcb && successcb(obj.unread_mail_cnt);
            } else {
                console.log('[reqGetUnreadMailCount]failed!' + obj.errcode + ":" + obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }

        }, (errcode, errmsg) => {
            console.log('[reqGetUnreadMailCount]failed!' + errcode + ":" + errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },
    //删除邮件
    reqDeleteMails(mailids, successcb, failcb) {
        if (!this.urlbd) {
            failcb && failcb(0, -1234, 'not inited!');
            return;
        }
        let lst = mailids instanceof Array ? mailids : [mailids];
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Mail')
            .addKV('a', 'deleteMails')
            .addKV('session_id', this.sessionid)
            .addKV('account_id', this.accountid)
            .addKV('mail_ids', lst.join());
        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if (obj && obj.errcode == 0) {
                console.log('[reqDeleteMails]success!' + JSON.stringify(obj));
                successcb && successcb(lst);
            } else {
                console.log('[reqDeleteMails]failed!' + obj.errcode + ":" + obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }

        }, (errcode, errmsg) => {
            console.log('[reqDeleteMails]failed!' + errcode + ":" + errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

};

module.exports = jcmail;
