
var httpclient = require('../common/httpclient');
var urlbuilder = require('../common/urlbuilder');

const GAME_TIME_KEY = 'jc_game_time_key';

let jcstat = {
    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    // start () {},

    // update (dt) {},
    _deftime: 60000,

    _tid: 0,

    _heart(){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Stat')
        .addKV('a', 'updateSession')
        .addKV('session_id', this.sessionid)
        .addKV('account_id', this.accountid);
        httpclient.httpGet(this.urlbd.baseurl, (res) => {
			if(!this.isoffical){
				console.log('[stat.heart]'+res);
			}
		}, (err, errmsg) => {
			if(!this.isoffical){
				console.log('[stat.heart]Err:'+err+'|'+errmsg);
			}
		});
    },

    init(channelid, gameid, isoffical, owner, url){
        this.owner = owner;
        this.gameid = gameid;
        this.channelid = channelid;
        this.isoffical = isoffical;
        this.urlbd = new urlbuilder(url);
        console.log("[jcstat]init:"+gameid + "|" + channelid + "|" + isoffical);
    },

    setAccountID(accountid, sessionid){
        this.accountid = accountid;
        this.sessionid = sessionid;
        this._heart();
        this.setHeart(this._deftime);
    },

    setNickName(nickname){
        this.nickname = nickname;
    },

    setFromAppID(appid){
        this.fromid = appid;
    },

    setLocalUUID(uuid){
        this.localid = uuid;
    },

    setSystemInfo(info){

    },

    setHeart(tm){
      if(tm && (typeof(tm) == 'number') && (tm > 0)){
        this._deftime = tm;
        if(this._tid){
          clearInterval(this._tid);
          this._tid = 0;
        }
        if(this.accountid && this.gameid != 1008){
          this._tid = setInterval(() => {
            this._heart();
          }, this._deftime);
        }
      }
    },

	  /**
   * 开启记录游戏时间
   * */
  registGameTimeHandle() {
    let self = this;
    let resetTime = this.getResetTime();
    console.log(`server reset time is: ${resetTime}`);
    this._beginTime = Date.now();
    let obj = {
      onJCGameShow: function (obj) {
        console.log('registGameTimeHandle game show');
        self._beginTime = Date.now();
      },
      onJCGameHide: function (obj) {
        console.log('registGameTimeHandle game hide');
        let now = Date.now();
        if (self._beginTime) {
          let time = parseInt((now - self._beginTime) / 1000);
          cc.rw.getStorage(GAME_TIME_KEY, function (value) {
            if (value) {
              time += parseInt(value);
            }
            cc.rw.setStorage(GAME_TIME_KEY, time, function () {
              self._beginTime = now;
            }, function () {
            }, 1, resetTime);
          }, function () {
            console.log()
          })
        }
      }
    }
    this.owner.addHandler(obj);
  },

  getGameTime(cb, fcb) {
    let time = 0;
    let now = Date.now();
    let resetTime = this.getResetTime();
    console.log(`this._beginTime" ${this._beginTime}, now: ${now}, val: ${(now - this._beginTime)/1000}`);
    let self = this;
    let timeDiff = 0;
    if (this._beginTime) {
      timeDiff = parseInt((now - this._beginTime) / 1000);
      time = timeDiff;
    } else {
      this._beginTime = now;
    }
    cc.rw.getStorage(GAME_TIME_KEY, function (value) {
      if (value) {
        time += parseInt(value);
      }
      if (timeDiff) {
        cc.rw.setStorage(GAME_TIME_KEY, time, function () {
          self._beginTime = now;
          cb && cb(time)
        }, function () {
          fcb && fcb()
        }, 1, resetTime);
      } else {
        cb && cb(time);
      }


    }, function () {
      fcb && fcb()
    })
  },

  getResetTime() {
    let time = 0;
    if (cc.jc.cloud.cfg['online_award'] && cc.jc.cloud.cfg['online_award']['reset_time']) {
      time = cc.jc.cloud.cfg['online_award']['reset_time'];
    }
    return time;
  },

};

module.exports = jcstat;
