// Type definitions for ./src/utils/dateutils.js
// Project: [LIBRARY_URL_HERE] 
// Definitions by: [YOUR_NAME_HERE] <[YOUR_URL_HERE]> 
// Definitions: https://github.com/borisyankov/DefinitelyTyped

/**
 * 日期和时间相关方法, 待扩充
 */
declare namespace dateutils{
		
	/**
	 * 获取当天的日期, 返回'YYYY-MM-DD'
	 * @return  
	 */
	function getToday(): string;
		
	/**
	 * 获取周一时间
	 * @param millseconds 
	 * @return  
	 */
	function getFirstDay(millseconds : number): Date;
		
	/**
	 * 时间转字符串
	 * @param dt 
	 * @return  
	 */
	function formatDateStr(dt : any): string;
		
	/**
	 * 按固定格式转日期字符串
	 * @param formatter 
	 * @param date 
	 */
	function dateFormatter(formatter : any, date : Date): void;
		
	/**
	 * dtime距当前多少天
	 */
	interface DateGetDay {
				
		/**
		 * 
		 * @param dtime 
		 * @return  
		 */
		new (dtime : number | Date): number;
	}

		
	/**
	 * 是否是同一周
	 * @param old 
	 * @param now 
	 * @return  
	 */
	function isSameWeek(old : any, now : any): boolean;
		
	/**
	 * 是否是同一天
	 * @param old 
	 * @param now 
	 * @return  
	 */
	function isSameDay(old : any, now : Date): boolean;
		
	/**
	 * 是否是昨天
	 * @param olddt 
	 * @return  
	 */
	function isSerialDay(olddt : any): boolean;
		
	/**
	 * 是否是今天
	 * @param day 
	 * @return  
	 */
	function isNowDay(day : any): boolean;
		
	/**
	 * 间隔天数
	 * @param time1 
	 * @param time2 
	 * @return  
	 */
	function betweenDays(time1 : any, time2 : any): number;
		
	/**
	 * 在当天的秒数
	 * @param time 
	 * @param incdays 
	 * @return  
	 */
	function getDaySeconds(time : number, incdays : number): number;
		
	/**
	 * 
	 * @return  
	 */
	function getCurrMillSeconds(): number;
		
	/**
	 * 
	 * @return  
	 */
	function getCurrSeconds(): number;
		
	/**
	 * 计算过期剩余秒数
	 * @param time_type 
	 * @param time_val 
	 * @param time_past 
	 * @return  
	 */
	function expiredSeconds(time_type : any, time_val : any, time_past : any): number;
		
	/**
	 * 将秒格式化成 天:小时:分:秒
	 * @param {number} countTime 要格式化的秒
	 * @param {number} showNum   要显示几个段, 比例 2, 则显示 x分: x秒, 3: x小时:x分:x秒
	 * @param countTime 
	 * @param showNum 
	 * @return  
	 */
	function formatSeconds(countTime : number, showNum : number): string;
}
