
let fileutils = {
    _islocal(url){
        return url.toLowerCase().indexOf('http')<0;
    },

    __LocalLoad(obj, restype, cb){
        if(cc.resources && cc.resources.load){
            if(restype){
                cc.resources.load(obj, restype, cb);
            }else{
                cc.resources.load(obj, cb);
            }
        }else{
            if(restype){
                cc.loader.loadRes(obj, restype, cb);
            }else{
                cc.loader.loadRes(obj, cb);
            }
        }
    },

    __RemoteLoad(obj, cb){
        if(cc.assetManager && cc.assetManager.loadRemote){
            cc.assetManager.loadRemote(obj, cb);
        }else{
            cc.loader.load(obj, cb);
        }
    },

    loadRes(url, cb){
        let islocal = this._islocal(url);
        if(islocal){
            this.__LocalLoad(url, null, cb);
        }else{
            this.__RemoteLoad(url, cb);
        }
    },

    loadImage(aurl, sprite, successcb, failcb){
        if(aurl){
            let tmp = aurl;
            let islocal = tmp.toLowerCase().indexOf('http')<0
            if(islocal){
                this.__LocalLoad(aurl, cc.SpriteFrame, function (err, frame) {
                    // Use texture to create sprite frame
                    if(err == null){
                        try{
                            if(sprite){
                                sprite.spriteFrame = frame;
                            }
                            successcb && successcb(sprite, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('loadImage err:'+ aurl+"|"+islocal);
                        console.log(err);
                        try{
                            failcb && failcb(err, sprite, aurl);
                        }catch(e){

                        }
                    }
                });
                return;
            }

            let idx = aurl.lastIndexOf('/');
            let str = aurl.substr(idx + 1, aurl.length - idx + 1);
            idx = str.lastIndexOf('.');
            if(idx > 0){
                this.__RemoteLoad(aurl, function (err, texture) {
                    // Use texture to create sprite frame
                    if(err == null){
                        try{
                            if(sprite){
                                sprite.spriteFrame = new cc.SpriteFrame(texture);
                            }
                            successcb && successcb(sprite, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('loadImage err:'+ aurl);
                        console.log(err);
                        try{
                            failcb && failcb(err, sprite, aurl);
                        }catch(e){

                        }
                    }
                });
            }else{
                this.__RemoteLoad({url: aurl, type: 'png'}, function (err, texture) {
                    // Use texture to create sprite frame
                    if(err == null){
                        try{
                            if(sprite){
                                sprite.spriteFrame = new cc.SpriteFrame(texture);
                            }
                            successcb && successcb(sprite, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('createimage err:'+ aurl);
                        console.log(err);
                        try{
                            failcb && failcb(err, sprite, aurl);
                        }catch(e){

                        }
                    }
                });
            }
        }else{
            failcb && failcb(-1, sprite, aurl);
        }
    },

    loadSound(aurl, successcb, failcb){
        if(aurl){
            let tmp = aurl;
            let islocal = tmp.toLowerCase().indexOf('http')<0;
            if(islocal){
                this.__LocalLoad(aurl, cc.AudioClip, function (err, clip) {
                    if(err == null){
                        try{
                            successcb && successcb(clip, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('loadSound err:'+ aurl+"|"+islocal);
                        console.log(err);
                        try{
                            failcb && failcb(null, aurl, err);
                        }catch(e){

                        }
                    }
                });
            }else{
                this.__RemoteLoad(aurl, function (err, clip) {
                    if(err == null){
                        try{
                            successcb && successcb(clip, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('loadSound err:'+ aurl+"|"+islocal);
                        console.log(err);
                        try{
                            failcb && failcb(null, aurl, err);
                        }catch(e){

                        }
                    }
                });
            }
        }else{
            failcb && failcb(null, aurl);
        }
    },

    loadText(aurl, successcb, failcb){
        if(aurl){
            let tmp = aurl;
            let islocal = tmp.toLowerCase().indexOf('http')<0;
            if(islocal){
                this.__LocalLoad(aurl, null, function (err, clip) {
                    if(err == null){
                        try{
                            successcb && successcb(clip.text, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('loadText err:'+ aurl+"|"+islocal);
                        console.log(err);
                        try{
                            failcb && failcb(null, aurl, err);
                        }catch(e){

                        }
                    }
                });
            }else{
                this.__RemoteLoad(aurl, function (err, clip) {
                    if(err == null){
                        try{
                            successcb && successcb(clip.text, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('loadText err:'+ aurl+"|"+islocal);
                        console.log(err);
                        try{
                            failcb && failcb(null, aurl, err);
                        }catch(e){

                        }
                    }
                });
            }
        }else{
            failcb && failcb(null, aurl);
        }
    },

    loadJson(aurl, successcb, failcb){
        if(aurl){
            let tmp = aurl;
            let islocal = tmp.toLowerCase().indexOf('http')<0;
            if(islocal){
                this.__LocalLoad(aurl, null, function (err, clip) {
                    if(err == null){
                        try{
                            successcb && successcb(clip.json, aurl);
                        }catch(e){

                        }
                    }else{
                        console.log('loadJson err:'+ aurl+"|"+islocal);
                        console.log(err);
                        try{
                            failcb && failcb(null, aurl, err);
                        }catch(e){

                        }
                    }
                });
            }else{
                this.__RemoteLoad(aurl, function (err, clip) {
                    if(err == null){
                        successcb && successcb(clip, aurl);
                    }else{
                        console.log('loadJson err:'+ aurl+"|"+islocal);
                        console.log(err);
                        try{
                            failcb && failcb(null, aurl, err);
                        }catch(e){

                        }
                    }
                });
            }
        }else{
            failcb && failcb(null, aurl);
        }
    }
};

module.exports = fileutils;
