var storage = require('../common/storage');

var COMMON_STORAGE = {
    /**
     * @param {string} skey
     * @param {string} svalue
     * @param {function} successcb
     * @param {function} failcb
     * @param {number} limitday 过期天数
     * @param {number} resetTime 几点重置
     * */
    setStorage: function(skey, svalue, successcb, failcb, limitday, resetTime) {
        let to = 0;
        let tv = 0;
        let rt = 0;
        if (typeof(resetTime) == 'number') {
            rt = resetTime * 3600;
        }
        if (limitday) {
            to = 2;
            tv = 3600 * 24 * limitday + rt;
        }

        if (this._isoffical && this.cloud && this._iscloud) {
            this.cloud.setStorage(skey, svalue, successcb, failcb, to, tv);
        } else {
            storage.setStorage(skey, svalue, successcb, failcb, to, tv);
        }
    },

    setStorages: function(kvlist, successcb, failcb) {
        if (this._isoffical && this.cloud && this._iscloud) {
            this.cloud.setStorages(kvlist, successcb, failcb);
        } else {
            storage.setStorages(kvlist, successcb, failcb);
        }
    },

    getStorage: function(key, successcb, failcb) {
        if (this._isoffical && this.cloud && this._iscloud) {
            this.cloud.getStorage(key, successcb, failcb);
        } else {
            storage.getStorage(key, successcb, failcb);
        }
    },

    getStorages: function(keylist, successcb, failcb) {
        if (this._isoffical && this.cloud && this._iscloud) {
            this.cloud.getStorages(keylist, successcb, failcb);
        } else {
            storage.getStorages(keylist, successcb, failcb);
        }
    },

    init(owner, isoffical, cloud) {
        this._owner = owner;
        this._isoffical = isoffical;
        this._iscloud = isoffical;
        if (CC_DEBUG) {
            //临时测试用
            this._iscloud = false;
            this._isoffical = false;
        }
        this.setCloud(cloud);
    },

    setCloud: function(cloud) {
        this.cloud = cloud;
    },

    setCloudFlag: function(iscloud) {
        this._iscloud = iscloud;
    },

    getCloudFlag: function() {
        return this._iscloud;
    }
}

cc.rw = COMMON_STORAGE;

module.exports = COMMON_STORAGE;
