
let strutils = {
    getLittleNumber(num){
        var plus = num.toFixed(2);
        if(num>=1000000000000000){
            plus = (num/1000000000000000).toFixed(1)+"aa"
        }
        else if(num>=1000000000000){
            plus = (num/1000000000000).toFixed(1)+"T"
        }
        else if(num>=1000000000){
            plus = (num/1000000000).toFixed(1)+"B"
        }
        else if(num>=1000000){
            plus = (num/1000000).toFixed(1)+"M"
        }
        else if(num>=1000){
            plus = (num/1000).toFixed(1)+"K"
        }else if(num < 1000){
            plus = Math.floor(num);
        }
        return plus;

    },

    getDotNumber(num){
        num = Math.floor(num);
        var plus = ""
        if(num>=1000000000000){
            plus = "("+(num/1000000000000).toFixed(1)+"T)"
        }
        else if(num>=1000000000){
            plus = "("+(num/1000000000).toFixed(1)+"B)"
        }
        else if(num>=1000000){
            plus = "("+(num/1000000).toFixed(1)+"M)"
        }
        else if(num>=1000){
            plus = "("+(num/1000).toFixed(1)+"K)"
        }

        var snum = num+"";
        var pos = 0;
        var numArr= [];
        for(var i=snum.length-1;i>=0;i--){
            if(pos==3){
                numArr.push(",")
                pos=0;
            }
            numArr.push(snum[i]);
            pos++;
        }
        snum = "";
        for(var i=numArr.length-1;i>=0;i--){
            snum+=numArr[i];
        }
        return snum+plus;
    },

    randomInt(nMax, nMin){
        let nmin = nMin || 0;
        var nRange = nMax - nmin;
        var Rand = Math.random();
        var num = nmin + Math.round(Rand * nRange); //四舍五入
        return num;
    },

    randomBool(percent, ratio){
        let n = ratio? ratio: 1;
        var num = Math.random() * n;
        return num < percent;
    },

    /**
     * 格式化金额显示
     * @param {Number} count 以分为单位的金额
     * @param {Number} 以元为单位的金额
     * */
    formatMoney(count) {
        return (count / 100).toFixed(2);
    },

    /**
     * 自定义String prototype 方法
     */
    initStringPrototype() {
        String.prototype.format = this._format;
    },
    /**
     * 字符串格式化
     * 调用实例如下
     */
    /*
    let test = [];
    test["name"] = "test";
    test["age"] = 21;
    console.log("我是{name}，今年{age}了".format(test));

    test = [];
    test[0] = "test2";
    test.push(21);
    console.log("我是{0}，今年{1}了".format(test));
    console.log("我是{0}，今年{1}了".format(test[0],test[1]));

    test = {};
    test.name = "test3";
    test.age = 21;
    console.log("我是{name}，今年{age}了".format(test));
    */
    _format(args) {
        if (arguments.length > 0)
        {
            var result = this;
            if (arguments.length == 1 && typeof (args) == "object")
            {
                if (Object.prototype.toString.call(args) === "[object Array]" &&
                    args.length > 0) {
                    for (var key in args)
                    {
                        var reg = new RegExp("({[" + key + "]})", "g");
                        result = result.replace(reg, args[key]);
                    }
                } else {
                    for (var key in args)
                    {
                        var reg = new RegExp("({" + key + "})", "g");
                        result = result.replace(reg, args[key]);
                    }
                }
            }
            else
            {
                for (var i = 0; i < arguments.length; i++)
                {
                    if (arguments[i] == undefined)
                    {
                        return "";
                    }
                    else
                    {
                        var reg = new RegExp("({[" + i + "]})", "g");
                        result = result.replace(reg, arguments[i]);
                    }
                }
            }
            return result;
        }
        else
        {
            return this;
        }
    }
};

module.exports = strutils;
