
class jcplayeritem{


    loadData(jsondata){
        this.accountid = jsondata.account_id;
        this.wid = jsondata.wid;
        this.sid = jsondata.sid;
        this.ptid = jsondata.ptid;
        this.gameid = jsondata.game_id;
        this.nickname = jsondata.nickname;
        this.avatarurl = jsondata.avatar_url;
        this.sex = jsondata.sex;
        this.city = jsondata.city;
        this.province = jsondata.province;
        this.gamescore = jsondata.gamescore;
        this.is_winner = jsondata.is_winner;
        this.appid = '';
        this.appicon = '';
        this.gameparam = {
            jc_player_name: this.nickname,
            jc_player_id: this.accountid,
            jc_player_wid: this.wid,
            jc_player_sid: this.sid,
            jc_player_ptid: this.ptid,
            jc_player_score: this.gamescore,
            jc_player_sex: this.sex,
            jc_from_id: this.owner.accountid,
            jc_from_wid: this.owner.wideID,
            jc_from_sid: this.owner.strongID,
            jc_from_ptid: this.owner.ptID,
            jc_from_sessionid: this.owner.sessionid,
        }
    }

    updateGameInfo(appid, appicon){
        if(this.appid != appid || this.appicon != appicon){
            this.appid = appid;
            this.appicon = appicon;
            this.owner && this.owner.onPlayerUpdateGame(this);
        }
    }

    setOwner(owner){
        this.owner = owner;
    }

    onClick(err){
        this.owner && this.owner.onPlayerClick(this, err);
    }

    updateByMsg(msg){
        if(msg.gameid != this.gameid){
            return;
        }

        let batt = (this.sid != '' && msg.attacker_sid == this.sid) || (this.wid != '' && msg.attacker_wid == this.wid);

        let bdef = (this.gameparam.jc_from_sid != '' && msg.defender_sid == this.gameparam.jc_from_sid)
            || (this.gameparam.jc_from_wid != '' && msg.defender_wid == this.gameparam.jc_from_wid);

        if(batt && bdef){
            this.is_winner = msg.pkresult == 1;
        }
    }
}
module.exports = jcplayeritem;
