var httpclient = require('../common/httpclient');
var urlbuilder = require('../common/urlbuilder');

var gameitem = require('./jcgameitem');
var playeritem = require('./jcplayeritem');

const GAME_LIMIT_COUNT = 9;
const GAME_MIN_COUNT = 3;
const GAME_MAX_TYPE = 3;

let jcvoodoo = {
    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },
    },

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    // start () {},

    // update (dt) {},
    __getGameType(gameid){
        let gr = 1000;
        let gn = 1;
        if(gameid > 100000){
            gr = 100000;
            gn = 100;
        }else if(gameid > 10000){
            gr = 10000;
            gn = 10;
        }

        let ngameid = parseInt(gameid / gn);

        if(ngameid == 1004 || ngameid == 1013){
            return 1;
        }
        if(ngameid == 1001 || ngameid == 1003 || ngameid == 1011 || ngameid == 1012 || ngameid == 1009){
            return 2;
        }
        if(ngameid == 1008){
            return 3;
        }

        return parseInt(gameid / gr);
    },

    init(channelid, gameid, isoffical, owner, url){
        if(this.inited){
            return;
        }
        this.gameid = gameid;
        this.channelid = channelid;
        this.nickname = this.nickname? this.nickname: '';
        this.gametype = this.__getGameType(gameid);
        if(this.gametype > GAME_MAX_TYPE){
            this.gametype = 0;
        }
        this.gamecbs = [];
        this.gamefailcbs = [];
        this.gamelist = [];
        this.playerlist = [];
        this.rmlst = [];
        this.hotlst = [];
        this.newlst = [];
        this.msglist = [];
        this.baseurl = url;
        this.isSimpleShow = false;
        this.urlbd = new urlbuilder(url);

        this.target_player = {
            name: '',
            id: '',
            wid: '',
            sid: '',
            ptid: '',
            sex: 0,
            score: -1
        };
        this.from_player = {
            id: '',
            wid: '',
            sid: '',
            ptid: ''
        };
        this.isChallengeMode = false;
        this._lastidx = 0;

        console.log("[jcgamemanager]init:"+gameid + "|" + channelid + "|" + isoffical);

        this.voodooID = 9001;
        this.inited = true;
    },

    setAccountID(accountid, sessionid, exobj){
        this.accountid = accountid;
        this.sessionid = sessionid;
        if(!exobj){
            return;
        }
        if(typeof(exobj.wid) != undefined){
            this.wideID = exobj.wid;
        }
        if(typeof(exobj.sid) != undefined){
            this.strongID = exobj.sid;
        }
        if(typeof(exobj.ptid) != undefined){
            this.ptID = exobj.ptid;
        }
        if(typeof(exobj.sex) != undefined){
            this.sex = exobj.sex;
        }
    },

    setNickName(nickname){
        this.nickname = nickname;
    },

    setFromAppID(appid){
        this.fromid = appid;
    },

    setLocalUUID(uuid){
        this.localid = uuid;
    },

    setUserInfo(info){
        this.sex = info? info.gender: 0;
    },

    setLaunchInfo(scene, fromid, lauchinfo){
        if(lauchinfo && lauchinfo.jc_player_name){
            this.target_player.name = lauchinfo.jc_player_name;
            this.target_player.id = lauchinfo.jc_player_id;
            this.target_player.sex = lauchinfo.jc_player_sex;
            this.target_player.score = lauchinfo.jc_player_score;
            this.target_player.wid = lauchinfo.jc_player_wid;
            this.target_player.sid = lauchinfo.jc_player_sid;
            this.target_player.ptid = lauchinfo.jc_player_ptid;

            this.from_player.id = lauchinfo.jc_from_id;
            this.from_player.wid = lauchinfo.jc_from_wid;
            this.from_player.sid = lauchinfo.jc_from_sid;
            this.from_player.ptid = lauchinfo.jc_from_ptid;
            this.from_player.sessionid = lauchinfo.jc_from_sessionid;

            this.isChallengeMode = true;
        }
    },

    setSystemInfo(info){

    },

    setNotifyHandler(handler){
        this._handler = handler;
    },

    reqGameListData(successcb, failcb){
        if(this.gamelstgetted){
            try{
                successcb && successcb(this);
            }catch(err){

            }
            return;
        }
        this._checkCbs(this.gamecbs, successcb);
        this._checkCbs(this.gamefailcbs, failcb);
        if(this._gamelstgetting){
            return;
        }
        this._gamelstgetting = true;
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Voodoo')
        .addKV('a', 'getRecommendGames')
        .addKV('game_id', this.gameid)
        .addKV('platform', this.channelid)
        .addKV('account_id', this.accountid)
        .addKV('session_id', this.sessionid);

        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            this._gamelstgetting = false;
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[reqGameListData]success!'+JSON.stringify(obj));
                //var gms = httpclient.JSON_parse(obj.game_list);
                var gms = obj.game_list;
                if(gms){
                    this.gamelist.length = 0;
                    gms.forEach(element => {
                        let obj = new gameitem();
                        obj.setOwner(this);
                        obj.loadData(element);
                        this.gamelist.push(obj);
                    });
                    this._parseGameList();
                    this._checkPlayersAppID();
                    this.gamecbs.forEach(element =>{
                        try{
                            element(this);
                        }catch(err){

                        }
                    });
                    this.gamelstgetted = true;
                }else{
                    this.gamefailcbs.forEach(element =>{
                        try{
                            element(0, -1, "restext is not obj:" + restext);
                        }catch(err){

                        }
                    });
                }
            }else{
                let err = obj? obj.errcode: -1234;
                let errmsg = obj? obj.errmsg: 'Parse Json Failed!';
                console.log('[reqGameListData]failed!'+err+":"+errmsg);
                this.gamefailcbs.forEach(element =>{
                    try{
                        element(0, err, errmsg);
                    }catch(err){

                    }
                });
            }
        }, (errcode, errmsg) => {
            this._gamelstgetting = false;
            console.log('[reqGameListData]failed!'+errcode+":"+errmsg);
            this.gamefailcbs.forEach(element =>{
                try{
                    element(errcode, 0, errmsg);
                }catch(err){

                }
            });
        });
    },

    reqPlayerListData(playercount, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Voodoo')
        .addKV('a', 'getRecommendPlayer')
        .addKV('game_id', this.gameid)
        .addKV('platform', this.channelid)
        .addKV('account_id', this.accountid)
        .addKV('session_id', this.sessionid)
        .addKV('need_count', playercount);

        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            console.log("[reqplayerlistdata result]");
            console.log(restext);
            var obj = httpclient.JSON_parse(restext);
            if(obj && obj.errcode == 0){
                console.log('[reqPlayerListData]success!'+JSON.stringify(obj));
                //var gms = httpclient.JSON_parse(obj.player_list);
                var gms = obj.player_list;
                if(gms){
                    this.playerlist.length = 0;
                    gms.forEach(element => {
                        let obj = new playeritem();
                        obj.setOwner(this);
                        obj.loadData(element);
                        this.playerlist.push(obj);
                    });
                    this._checkPlayersAppID();
                    successcb && successcb(this);
                }else{
                    failcb && failcb(0, -1, "restext is not obj:" + restext);
                }
            }else{
                let err = obj? obj.errcode: -1234;
                let errmsg = obj? obj.errmsg: 'Parse Json Failed!';
                console.log('[reqPlayerListData]failed!'+err+":"+errmsg);
                failcb && failcb(0, err, errmsg);
            }
        }, (errcode, errmsg) => {
            console.log('[reqPlayerListData]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    postClickData(gameid, successcb, failcb){
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Voodoo')
        .addKV('a', 'updateClick')
        .addKV('game_id', gameid)
        .addKV('platform', this.channelid)
        .addKV('account_id', this.accountid)
        .addKV('session_id', this.sessionid);

        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[postClickData]success!'+JSON.stringify(obj));
                successcb && successcb(this);
            }else{
                console.log('[postClickData]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, (errcode, errmsg) => {
            console.log('[reqPlayerListData]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    postGameResult(gamescore, successcb, failcb){
        console.log('[postGameResult]');
        this.urlbd.clear();
        this.urlbd.addKV('c', 'Voodoo')
        .addKV('a', 'reportPvpResult')
        .addKV('account_id', this.accountid)
        .addKV('session_id', this.sessionid)
        .addKV('sid', this.strongID)
        .addKV('wid', this.wideID)
        .addKV('ptid', this.ptID)
        .addKV('nick_name', this.nickname)
        .addKV('score', gamescore)
        .addKV('sex', this.sex)
        .addKV('from_account_id', this.from_player.id)
        .addKV('from_session_id', this.from_player.sessionid)
        .addKV('from_sid', this.from_player.sid)
        .addKV('from_wid', this.from_player.wid)
        .addKV('from_ptid', this.from_player.ptid)
        .addKV('defender_id', this.target_player.id)
        .addKV('defender_sid', this.target_player.sid)
        .addKV('defender_wid', this.target_player.wid)
        .addKV('defender_ptid', this.target_player.ptid)
        .addKV('defender_name', this.target_player.name)
        .addKV('defender_score', this.target_player.score)
        .addKV('defender_sex', this.target_player.sex)
        .addKV('pkresult', this.getPkResult(gamescore));

        httpclient.httpGet(this.urlbd.baseurl, (restext) => {
            var obj = httpclient.JSON_parse(restext);
            if(obj.errcode == 0){
                console.log('[postGameResult]success!'+JSON.stringify(obj));
                successcb && successcb(this);
            }else{
                console.log('[postGameResult]failed!'+obj.errcode+":"+obj.errmsg);
                failcb && failcb(0, obj.errcode, obj.errmsg);
            }
        }, (errcode, errmsg) => {
            console.log('[reqPlayerListData]failed!'+errcode+":"+errmsg);
            failcb && failcb(errcode, 0, errmsg);
        });
    },

    getPkResult(score){
        let n = score > this.target_player.score? 1: 0;
        return n;
    },

    onGameClick(game, err){
        this.postClickData(game.gameid);
        this._handler && this._handler.onJCGameClick(game, err);
    },

    onPlayerClick(player, err){
        this._handler && this._handler.onJCPlayerClick(player, err);
    },

    onPlayerUpdateGame(player){
        this._handler && this._handler.onJCPlayerUpdateGame(player);
    },

    hanldeMsgs(msglst){
        this.msglist.length = 0;
        for(var i = 0; i < msglst.length; ++i){
            let msg = msglst[i];
            if(msg.name == 'voodoo.pvp'){
                let obj = httpclient.JSON_parse(msg.content);
                this.msglist.push(obj);
            }
        }

        this.playerlist.forEach(element => {
            this.msglist.forEach(item => {
                element.updateByMsg(item);
            })
        });
    },

    getOneMsg(){
        if(!this.msglist){
            return '';
        }
        if(this._lastidx >= this.msglist.length){
            this._lastidx = this.msglist.length > 0? 0: -1;
        }
        if(this._lastidx < this.msglist.length && this._lastidx >= 0){
            let obj = this.msglist[this._lastidx];
            this._lastidx++;
            return obj;
        }
        return null;
    },

    buildMsgStr(msg){
        if(!msg){
            return '';
        }
        let res = msg.pkresult == 0? '但遗憾落败': '击败对手并挑战成功！';

        let attstr = msg.attacker_wid == this.wideID? '你': msg.attacker_name;

        let defstr = msg.defender_wid == this.wideID? '你': msg.defender_name;

        let str = attstr + '刚刚在' + msg.game_name + '中挑战' + defstr + '，' + res;

        return str;
    },

    _parseGameList(){
        this.rmlst.length = 0;
        this.hotlst.length = 0;
        this.newlst.length = 0;

        this.isSimpleShow = this.gamelist.length < GAME_LIMIT_COUNT;
        if(this.isSimpleShow){
            for(let i = 0;i < this.gamelist.length; ++i){
                if(i < 3){
                    this.rmlst.push(this.gamelist[i]);
                }else if( i >= 3 && i < 6){
                    this.hotlst.push(this.gamelist[i]);
                }else {
                    this.newlst.push(this.gamelist[i]);
                }
            }
            return;
        }

        let games = [];
        for(let i = 0; i < GAME_MAX_TYPE; i++){
            let lst = [];
            games.push(lst);
        }
        //解析类型（同时生成新游列表）
        this.gamelist.forEach(element =>{
            if(element.gameid == this.gameid){
                return;
            }
            if(!element.isopened){
                return;
            }
            if(element.isrecommend){
                this.rmlst.unshift(element);
                element.rmadded = true;
            }else if(element.ishot){
                this.hotlst.unshift(element);
                element.hotadded = true;
            }

            if(element.isnew){
                this.newlst.push(element);
            }

            if(element.type < GAME_MAX_TYPE){
                games[element.type].push(element);
            }else{
                console.log("error gametype!");
                console.log(JSON.stringify(element));
            }
        });

        //生成推荐列表
        let lst = games[this.gametype];
        lst.forEach(element => {
            if(!element.rmadded){
                this.rmlst.push(element);
                element.rmadded = true;
            }
        });
        if(this.rmlst.length < GAME_MIN_COUNT){
            let ntype = 0;
            while(ntype < GAME_MAX_TYPE){
                if(ntype == this.gametype){
                    ntype++;
                    continue;
                }
                let lst = games[ntype];
                lst.forEach(element => {
                    if(!element.rmadded){
                        this.rmlst.push(element);
                        element.rmadded = true;
                    }
                });
                ntype++;
            }
        }

        //生成热搜列表
        let maxlength = 0;
        for(let i = 0; i < GAME_MAX_TYPE; i++){
            let lst = games[i];
            if(lst.length > nmaxlength){
                maxlength = lst.length;
            }
        }
        let nidx = 0;
        while(nidx < maxlength){
            for(let i = 0; i < GAME_MAX_TYPE; i++){
                if(i == this.gametype){
                    continue;
                }
                let lst = games[i];
                if(nidx < lst.length){
                    let obj = lst[nidx];
                    if(!obj.hotadded){
                        this.hotlst.push(obj);
                        obj.hotadded = true;
                    }
                }
            }
            nidx++;
        }
    },

    _checkPlayersAppID(){
        if(this.playerlist.length > 0 && this.gamelist.length > 0){
            this.playerlist.forEach(element => {
                let obj = this.gamelist.find((item) =>{
                    return item.gameid == element.gameid;
                });
                if(obj){
                    element.updateGameInfo(obj.appid, obj.icon);
                }
            });
        }
    },

    _checkCbs(cblst, cb){
        if(cb){
            let bfind = cblst.find(element =>{
                return element == cb;
            });
            if(!bfind){
                cblst.push(cb);
            }
        }
    }
};
module.exports = jcvoodoo;
